--Virus gamemode for SRB2 Kart - Made by Ryason55

rawset(_G, "cv_vir_enable", CV_RegisterVar({
	name = "vir_enabled",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff,
}))

rawset(_G, "cv_vir_minplayers", CV_RegisterVar({
	name = "vir_minplayers",
	defaultvalue = 4,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 0, MAX = 16},
}))

rawset(_G, "cv_vir_team_chance", CV_RegisterVar({
	name = "vir_team_chance",
	defaultvalue = 50,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 0, MAX = 100},
}))

rawset(_G, "cv_vir_team_minplayers", CV_RegisterVar({
	name = "vir_team_minplayers",
	defaultvalue = 6,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 4, MAX = 16},
}))

rawset(_G, "cv_vir_team_balancedteams", CV_RegisterVar({
	name = "vir_team_balance",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff,
}))

freeslot("SPR_VRAR")
freeslot("S_VIRUSINFECTEDARROW")
freeslot("S_VIRUSINFECTEDARROW_BOX")
freeslot("S_VIRUSRUNNERARROW")
freeslot("S_VIRUSRUNNERARROW2")
freeslot("S_VIRUSRUNNERARROW_BOX")
freeslot("S_VIRUSRUNNERARROW2_BOX")
freeslot("S_VIRUSRUNNERARROWALLY")
freeslot("S_VIRUSRUNNERARROWALLY_BOX")
freeslot("S_VIRUSINFECTEDARROWALLY")
freeslot("S_VIRUSINFECTEDARROWALLY_BOX")
freeslot("MT_VIRUSPLAYERARROW")
freeslot("MT_VIRUSWANTED")
states[S_VIRUSINFECTEDARROW] = {SPR_VRAR, FF_FULLBRIGHT, -1, nextstate = S_NULL}
states[S_VIRUSINFECTEDARROW_BOX] = {SPR_VRAR, FF_FULLBRIGHT|1, -1, nextstate = S_NULL}
states[S_VIRUSRUNNERARROW] = {SPR_VRAR, FF_FULLBRIGHT|2, -1, nextstate = S_NULL}
states[S_VIRUSRUNNERARROW2] = {SPR_VRAR, FF_FULLBRIGHT|3, -1, nextstate = S_NULL}
states[S_VIRUSRUNNERARROW_BOX] = {SPR_VRAR, FF_FULLBRIGHT|4, -1, nextstate = S_NULL}
states[S_VIRUSRUNNERARROW2_BOX] = {SPR_VRAR, FF_FULLBRIGHT|5, -1, nextstate = S_NULL}
states[S_VIRUSRUNNERARROWALLY] = {SPR_VRAR, FF_FULLBRIGHT|6, -1, nextstate = S_NULL}
states[S_VIRUSRUNNERARROWALLY_BOX] = {SPR_VRAR, FF_FULLBRIGHT|7, -1, nextstate = S_NULL}
states[S_VIRUSINFECTEDARROWALLY] = {SPR_VRAR, FF_FULLBRIGHT|8, -1, nextstate = S_NULL}
states[S_VIRUSINFECTEDARROWALLY_BOX] = {SPR_VRAR, FF_FULLBRIGHT|9, -1, nextstate = S_NULL}
mobjinfo[MT_VIRUSPLAYERARROW] =
	{ 
		-1,             // doomednum
		S_VIRUSRUNNERARROW,  // spawnstate
		1000,           // spawnhealth
		S_NULL,         // seestate
		sfx_None,       // seesound
		8,              // reactiontime
		sfx_None,       // attacksound
		S_NULL,         // painstate
		0,              // painchance
		sfx_None,       // painsound
		S_NULL,         // meleestate
		S_NULL,         // missilestate
		S_NULL,         // deathstate
		S_NULL,         // xdeathstate
		sfx_None,       // deathsound
		8,              // speed
		36*FRACUNIT,    // radius
		37*FRACUNIT,    // height
		-2,             // display offset
		16,             // mass
		0,              // damage
		sfx_None,       // activesound
		MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY|MF_DONTENCOREMAP, // flags
		S_NULL          // raisestate
	}
mobjinfo[MT_VIRUSWANTED] =
	{
		-1,             // doomednum
		S_PLAYERARROW_WANTED1,  // spawnstate
		1000,           // spawnhealth
		S_NULL,         // seestate
		sfx_None,       // seesound
		8,              // reactiontime
		sfx_None,       // attacksound
		S_NULL,         // painstate
		0,              // painchance
		sfx_None,       // painsound
		S_NULL,         // meleestate
		S_NULL,         // missilestate
		S_NULL,         // deathstate
		S_NULL,         // xdeathstate
		sfx_None,       // deathsound
		8,              // speed
		36*FRACUNIT,    // radius
		37*FRACUNIT,    // height
		-2,             // display offset
		16,             // mass
		0,              // damage
		sfx_None,       // activesound
		MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY|MF_DONTENCOREMAP, // flags
		S_NULL          // raisestate
	}
	
local vir_playerarrowstates = {S_VIRUSINFECTEDARROW, S_VIRUSRUNNERARROW, S_VIRUSRUNNERARROW2, S_PLAYERARROW, S_VIRUSRUNNERARROWALLY,S_VIRUSINFECTEDARROWALLY,
										 S_VIRUSINFECTEDARROW_BOX, S_VIRUSRUNNERARROW_BOX, S_VIRUSRUNNERARROW2_BOX, S_PLAYERARROW_BOX, S_VIRUSRUNNERARROWALLY_BOX,S_VIRUSINFECTEDARROWALLY_BOX}

--global variables
local vir_starttime = 10*TICRATE --10 seconds after map start (3 seconds after the countdown ends)
local vir_shieldtime = 10*TICRATE --Time before Thunder Shield is automatically used
local vir_hitfeediconanim = {4,3}
local vir_minimapdirectionpatches = {} --Patch Name, Min Angle, Max Angle
for i = 0,35,1 do
	local patchname
	if i < 10 then
		patchname = "K_VRMD0"..i
	else
		patchname = "K_VRMD"..i
	end
	local anglemin = ((i*-10)+90)-5
	if anglemin < 0 then
		anglemin = anglemin + 360
	end
	local anglemax = ((i*-10)+90)+5
	if anglemax > 360 then
		anglemax = anglemax - 360
	end
	table.insert(vir_minimapdirectionpatches,{patchname,anglemin*ANG1,anglemax*ANG1})
end
local vir_teamtextcolor = {}
vir_teamtextcolor[0] = ""
vir_teamtextcolor[1] = "\x85"
vir_teamtextcolor[2] = "\x84"
local vir_facehighlightpatchnames = {}
for i = 1,8,1 do
	table.insert(vir_facehighlightpatchnames,"K_CHILI"..i)
end

--thunder shield related (based on official values)
local vir_thunderradius = 320
local vir_angletofineshift = 19

--local only variables (for local sounds and player arrows)
local vir_localviewers = {}
local vir_localplayerisinfected = false
local vir_localplayerisrunner = false
local vir_hudmem
local vir_localteam = 0

local vir_itemdoesntdrop = {}
vir_itemdoesntdrop[3] = true	--Invincibility
vir_itemdoesntdrop[5] = true	--Eggman Box
vir_itemdoesntdrop[10] = true	--SPB
vir_itemdoesntdrop[13] = true	--Thunder Shield (shouldn't even be able to drop)
vir_itemdoesntdrop[14] = true	--Hyudoro

local vir_sourcedoesntinfect = {} --To ensure that player projectiles that no longer have an owner can't damage resistance
vir_sourcedoesntinfect[MT_BANANA] = true
vir_sourcedoesntinfect[MT_BANANA_SHIELD] = true
vir_sourcedoesntinfect[MT_ORBINAUT] = true
vir_sourcedoesntinfect[MT_ORBINAUT_SHIELD] = true
vir_sourcedoesntinfect[MT_JAWZ] = true
vir_sourcedoesntinfect[MT_JAWZ_DUD] = true
vir_sourcedoesntinfect[MT_JAWZ_SHIELD] = true
vir_sourcedoesntinfect[MT_SSMINE_SHIELD] = true
vir_sourcedoesntinfect[MT_SSMINE] = true
vir_sourcedoesntinfect[MT_MINEEXPLOSION] = true
vir_sourcedoesntinfect[MT_BALLHOG] = true
vir_sourcedoesntinfect[MT_BALLHOGBOOM] = true
vir_sourcedoesntinfect[MT_SPB] = true --only true for players that happen to get hit on the way to the intended target
vir_sourcedoesntinfect[MT_SPBEXPLOSION] = true

local vir_teamcolors = {} --Team Color, Base Infected Color, Infected Text/Map Flash, Runner Text/Map Flash
vir_teamcolors[0] = {SKINCOLOR_PURPLE,SKINCOLOR_GSUPER3,SKINCOLOR_EMERALD,SKINCOLOR_CRIMSON}
vir_teamcolors[1] = {SKINCOLOR_RED,SKINCOLOR_KSUPER3,SKINCOLOR_ROSE,SKINCOLOR_CRIMSON}
vir_teamcolors[2] = {SKINCOLOR_BLUE,SKINCOLOR_BSUPER3,SKINCOLOR_CERULEAN,SKINCOLOR_BLUEBERRY}

addHook("NetVars", function(net)
	local netvars = {"vir_infectionstarted", "vir_endinground", "vir_lastscoreupdate", "vir_lastinfecttime", "vir_lastplayerstarttime", "vir_lastplayermode", "vir_enabled", "vir_lastspbtime", "vir_spbinplay", "vir_spbtarget", "vir_playerwithspb", "vir_activespb", "vir_playerwithshield", "vir_hyudorocooldown", "vir_eggboxesinplay", "vir_playernames", "vir_playerhasbeeninitial", "vir_playerleftafterinitial","vir_teamsenabled","vir_playerprefcolors","vir_rngseed","vir_spbteam"}
	for i = 1, #netvars
		server[netvars[i]] = net(server[netvars[i]])
	end
end)

local VIR_ResetPlayerData =
	function(i)
		players[i].vir_infected = 0
		players[i].vir_caninfect = false
		players[i].vir_initialinfected = false
		players[i].vir_preserveditemtype = KITEM_NONE
		players[i].vir_preserveditemcount = 0
		players[i].vir_wasspectating = false
		players[i].vir_health = 3
		players[i].vir_falling = false
		players[i].vir_itemroulette = 0
		players[i].vir_lastmovetime = vir_starttime
		players[i].vir_lastmovex = nil
		players[i].vir_lastmovey = nil --z being up is weird to me after serious sam
		players[i].vir_usingshield = false
		players[i].vir_autouseshieldtime = 0
		players[i].vir_team = 0
		if players[i] and players[i].valid then
			server.vir_playernames[i] = players[i].name
			if server.vir_playerleftafterinitial[players[i].name] then --If a player reconnects with the same name after having been an initial infected this rotation, make sure they get flagged as hasbeeninitial
				server.vir_playerleftafterinitial[players[i].name] = false
				server.vir_playerhasbeeninitial[i] = true
			end
		else
			server.vir_playernames[i] = nil
		end
	end
	
local VIR_RestorePrefColors =
	function()
		if server.vir_playerprefcolors then
			for i = 0,15,1 do
				if players[i] and players[i].valid and server.vir_playerprefcolors[i] then
					players[i].skincolor = server.vir_playerprefcolors[i]
					if players[i].mo then
						players[i].mo.color = server.vir_playerprefcolors[i]
					end
					server.vir_playerprefcolors[i] = nil
				end
			end
		end
		server.vir_playerprefcolors = nil
	end
	
addHook("MapLoad", do
	server.vir_enabled = cv_vir_enable.value and G_BattleGametype()
	if server.vir_enabled and cv_vir_minplayers.value then
		local validplayers = 0
		for i = 0,15,1 do
			if players[i] and players[i].valid and (not players[i].spectator) then
				validplayers = validplayers + 1
			end
		end
		if validplayers < cv_vir_minplayers.value then
			server.vir_enabled = false
			print("Not enough players for Virus; Playing Bumper Battle instead")
		end
	end
	VIR_RestorePrefColors() --In case Intermission Thinker didn't catch it
	if server.vir_enabled then
		server.vir_infectionstarted = false
		server.vir_endinground = false
		server.vir_lastscoreupdate = vir_starttime
		server.vir_lastinfecttime = vir_starttime
		server.vir_lastplayerstarttime = 0
		server.vir_lastplayermode = false
		server.vir_lastspbtime = vir_starttime
		server.vir_spbinplay = false
		server.vir_spbtarget = nil
		server.vir_spbteam = -1
		server.vir_playerwithspb = -1
		server.vir_activespb = nil
		server.vir_playerwithshield = -1
		server.vir_hyudorocooldown = vir_starttime + (5*TICRATE)
		server.vir_eggboxesinplay = 0
		server.vir_playernames = {}
		if not server.vir_playerhasbeeninitial then
			server.vir_playerhasbeeninitial = {} --has to be stored separately from player struct; indexed by player id
		end
		if not server.vir_playerleftafterinitial then
			server.vir_playerleftafterinitial = {} --indexed by name
		end
		vir_localviewers = {}
		local rngseed = 0 --Get the RNG seed from the position of the first 3 players found
		local validplayers = {}
		for i = 0,15,1 do
			if players[i] then
				VIR_ResetPlayerData(i)
				if players[i].valid and (not players[i].spectator) and players[i].mo then
					table.insert(validplayers,players[i])
					if #validplayers <= 3 then
						rngseed = rngseed + abs(players[i].mo.x) + abs(players[i].mo.y)
					end
				end
			end
		end
		server.vir_rngseed = abs(rngseed)
		--print(server.vir_rngseed,server.vir_rngseed%100,cv_vir_team_chance.value,#validplayers%2)
		if (#validplayers >= cv_vir_team_minplayers.value) and (#validplayers%2 == 0 or (not cv_vir_team_balancedteams.value)) and (server.vir_rngseed%100 < cv_vir_team_chance.value) then
			server.vir_teamsenabled = true
			server.vir_rngseed = server.vir_rngseed / 3
			local teamtoapply = 1
			if (#validplayers%2 == 1) and (server.vir_rngseed/5) == 0 then --If there's an odd number of players, 50% chance of starting with blue team
				teamtoapply = 2
			end
			for i = 1,#validplayers,1 do
				local index
				if i < #validplayers then
					index = ((server.vir_rngseed/(#validplayers-(i-1)))%#validplayers)+1
					--print(server.vir_rngseed/(#validplayers-(i-1)).."%"..#validplayers)
					if index < 1 then --sanity check
						index = 1
					end
				else
					index = 1
				end
				--print(index)
				while true do
					if validplayers[index].vir_team == 0 then
						validplayers[index].vir_team = teamtoapply + 0
						--print(teamtoapply.." "..validplayers[index].name)
						if teamtoapply == 1 then
							teamtoapply = 2
						else
							teamtoapply = 1
						end
						break
					end
					index = index + 1
					if index > #validplayers then
						index = 1
					end
				end
			end
		else
			server.vir_teamsenabled = false
		end
		hud.disable("wanted")
		hud.disable("minimap")
		hud.disable("gametypeinfo")
		hud.disable("battlerankingsbumpers")
		hud.disable("minirankings")
	else
		hud.enable("wanted")
		hud.enable("minimap")
		hud.enable("gametypeinfo")
		hud.enable("battlerankingsbumpers")
		hud.enable("minirankings")
	end
	hud.enable("time")
end)

addHook("IntermissionThinker",do
	VIR_RestorePrefColors()
end)

--Persistent player vars include:
-- vir_recentlybeeninitial


local VIR_IsLocalPlayer = 
	function(player)
		for i = 1,#vir_localviewers,1 do
			if player == vir_localviewers[i] then
				return true
			end
		end
		return false
	end


--DrawMKText by ampersand: Draws text in the MK Font
local mkfnt = {}
for i = 1, 255
		local s = string.format("MKFNT%03d", i)
		mkfnt[i] = s
end

local VIR_DrawMKText =
	function(v, str, x, y, flags, align)
		if str == "" then str = "-" end
		if str == nil then str = "nil" end
		str = tostring(str)
		str = str:upper()
		local dt = {}
		local offset = 0
		for i = 1,#str do
			local by = string.byte(str:sub(i,i))
			if mkfnt[by] ~= nil
			and v.patchExists(mkfnt[by])		-- if patch exists, ready it
				local pp = v.cachePatch(mkfnt[by])
				dt[#dt+1] = {pp, offset}
				offset = $ + pp.width
			else
				offset = $ + 16
			end
		end

		local eo = 0
		if align == "center" then
			eo = offset/2
		end
		if align == "right" then
			eo = offset
		end
		
		for i = 1,#dt do
			local ix = dt[i]
			v.draw(x+ix[2]-eo, y, ix[1], flags)
		end
	end

hud.add(function(v, p, c) --Most of the HUD stuff is pretty much directly ripped from Battle Plus, because I have no idea :V
	if not server.vir_enabled then return end
	if not server.vir_endinground then
		
		if server.vir_lastplayermode then --Replaces normal timer during Last Player mode (Counts down from 30)
			hud.disable("time")
			local hx, hy, flags -- hx/hy is for the backdrop, we get the number positions from maths
			if (splitscreen) > 1 -- 3/4 players
				hx, hy, flags = 90, 3, V_SNAPTOTOP|V_HUDTRANS
			else -- 1/2 players
				hx, hy, flags = 172, 9-((splitscreen) and 6 or 0), V_SNAPTOTOP|V_SNAPTORIGHT|V_HUDTRANS
			end
			
			v.draw(hx, hy, v.cachePatch("K_STTIMW"), flags)
			local timediff = max(0,(30*TICRATE) - (leveltime - server.vir_lastplayerstarttime))
			local m = G_TicsToMinutes(timediff, true)
			local s = G_TicsToSeconds(timediff)
			local c = G_TicsToCentiseconds(timediff)
					
			VIR_DrawMKText(v, (m < 10 and "0"..m or m).."'"..(s < 10 and "0"..s or s).."\""..(c < 10 and "0"..c or c), hx+129, hy+3, flags, "right")
		end
		
		if not p.spectator and not p.vir_infected then --Non-infected player health
			local healthtext = p.vir_health.." / 3"
			if splitscreen then
				if (splitscreen) == 1 then -- 2 local players
					local hy1, hy2 = c.pnum == 2 and 171 or 71, c.pnum == 2 and 179 or 79
					local flags = (c.pnum == 2 and V_SNAPTOBOTTOM or 0)|V_SNAPTOLEFT|((p.vir_health >= 3) and V_HUDTRANSHALF or V_HUDTRANS)
					
					--TODO: Eventually I'll want actual icons for these
					--v.draw(9, hy1, v.cachePatch((p.rr_debt and leveltime%10 >= 5) and "K_STDNGN" or p.rr_flash and "K_STFNGN" or "K_STRNGN"), flags)
					VIR_DrawMKText(v, healthtext, 10, hy2, flags, "left")
				else -- 3+ players
					local hx1, hx2 = (c.pnum == 2 or c.pnum == 4) and 280 or 3, (c.pnum == 2 or c.pnum == 4) and 315 or 5
					local hy1, hy2 = c.pnum > 2 and 186 or 86, c.pnum > 2 and 188 or 88
					local flags = (c.pnum > 2 and V_SNAPTOBOTTOM or 0)|((c.pnum == 2 or c.pnum == 4) and V_SNAPTORIGHT or V_SNAPTOLEFT)|((p.vir_health >= 3) and V_HUDTRANSHALF or V_HUDTRANS)
					local align = (c.pnum == 2 or c.pnum == 4) and "right" or "left"
					
					--v.draw(hx1, hy1, v.cachePatch((p.rr_debt and leveltime%10 >= 5) and "K_DNGICO" or p.rr_flash and "K_FNGICO" or "K_RNGICO"), flags)
					v.drawString(hx2, hy2, healthtext, flags, align)
				end
			else
				--v.draw(9, 166, v.cachePatch((p.rr_debt and leveltime%10 >= 5) and "K_STDNGN" or p.rr_flash and "K_STFNGN" or "K_STRNGN"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS)
				VIR_DrawMKText(v, healthtext, 15, 174, V_SNAPTOBOTTOM|V_SNAPTOLEFT|((p.vir_health >= 3) and V_HUDTRANSHALF or V_HUDTRANS), "left")
			end
		end
		
		if (not p.vir_infected) and (p.kartstuff[k_itemtype] == KITEM_THUNDERSHIELD) and p.vir_autouseshieldtime then --Timer bar for Thunder Shield
			local remainingtime = ((p.vir_autouseshieldtime - leveltime)*FRACUNIT)/vir_shieldtime --Effectively a ratio between 0 and 1 (in FRACUNITs)
			if (splitscreen)
				if (splitscreen) == 1 -- 2 players
					local barlength = (remainingtime*27)/FRACUNIT
					local hy3 = c.pnum == 2 and 103 or 3
					local flags2 = (c.pnum == 1 and V_SNAPTOTOP or 0)|V_SNAPTOLEFT|V_HUDTRANS
					v.draw(16, hy3+35, v.cachePatch("K_ITIMER"), flags2)
					-- main bar
					v.drawFill(17, hy3+36, barlength, 1, 120|flags2)
					v.drawFill(17, hy3+37, barlength, 1, 8|flags2)
					-- borders
					if barlength > 0 then v.drawFill(17, hy3+36, 1, 2, 12|flags2) end
					if barlength > 1 then v.drawFill(16+barlength, hy3+36, 1, 2, 12|flags2) end
				else -- 3+ players
					local barlength = (remainingtime*13)/FRACUNIT
					local hx3 = (c.pnum == 2 or c.pnum == 4) and 281 or -9
					local hy3 = c.pnum > 2 and 92 or -8
					local flags2 = ((c.pnum == 1 or c.pnum == 2) and V_SNAPTOTOP or 0)|((c.pnum == 2 or c.pnum == 4) and V_SNAPTORIGHT or V_SNAPTOLEFT)|V_HUDTRANS
					v.draw(hx3+17, hy3+27, v.cachePatch("K_ISIMER"), flags2)
					-- main bar
					v.drawFill(hx3+18, hy3+28, barlength, 1, 120|flags2)
					-- borders
					if barlength > 0 then v.drawFill(hx3+18, hy3+28, 1, 1, 12|flags2) end
					if barlength > 1 then v.drawFill(hx3+17+barlength, hy3+28, 1, 1, 12|flags2) end
				end
			else -- 1 player
				local barlength = (remainingtime*27)/FRACUNIT
				v.draw(16, 40, v.cachePatch("K_ITIMER"), V_SNAPTOTOP|V_SNAPTOLEFT|V_HUDTRANS)
				-- main bar
				v.drawFill(17, 41, barlength, 1, 120|V_SNAPTOTOP|V_SNAPTOLEFT|V_HUDTRANS)
				v.drawFill(17, 42, barlength, 1, 8|V_SNAPTOTOP|V_SNAPTOLEFT|V_HUDTRANS)
				-- borders
				if barlength > 0 then v.drawFill(17, 41, 1, 2, 12|V_SNAPTOTOP|V_SNAPTOLEFT|V_HUDTRANS) end
				if barlength > 1 then v.drawFill(16+barlength, 41, 1, 2, 12|V_SNAPTOTOP|V_SNAPTOLEFT|V_HUDTRANS) end
			end
		end
		
		if p.vir_infected and (p.vir_infected+3*TICRATE >= leveltime) then --"Infected!" text
			if splitscreen then
				if (splitscreen) == 1 then -- 2 local players
					local hy1 = c.pnum == 2 and 115 or 15
					local flags = (c.pnum == 2 and V_SNAPTOBOTTOM or 0)|V_HUDTRANS
					
					VIR_DrawMKText(v, "Infected", 160, hy1, flags, "center")
				else -- 3+ players
					local hx1 = (c.pnum == 2 or c.pnum == 4) and 240 or 80
					local hy1 = c.pnum > 2 and 115 or 15
					local flags = (c.pnum > 2 and V_SNAPTOBOTTOM or 0)|((c.pnum == 2 or c.pnum == 4) and V_SNAPTORIGHT or V_SNAPTOLEFT)|V_HUDTRANS
						
					v.drawString(hx1, hy1, "Infected!", flags, "center")
				end
			else
				VIR_DrawMKText(v, "Infected", 160, 45, V_HUDTRANS, "center")
			end
		end
		
		if (not splitscreen) and (leveltime < (vir_starttime - TICRATE)) then --Announce the gamemode at the start of the match
			v.drawString(160, 45, "You are playing:", V_HUDTRANS|V_YELLOWMAP, "center")
			if server.vir_teamsenabled then
				v.drawString(160, 55, "Team Virus", V_HUDTRANS|V_GREENMAP, "center")
				v.drawString(160, 70, "Infect the enemy team!", V_HUDTRANS, "center")
			else
				v.drawString(160, 55, "Virus", V_HUDTRANS|V_GREENMAP, "center")
				v.drawString(160, 70, "Don't get infected!", V_HUDTRANS, "center")
			end
		end
		
		if server.vir_lastplayermode and c.pnum == 1 then --Wanted poster for Last Player mode
			for i = 0,15,1 do
				if players[i] and players[i].valid and (not players[i].spectator) and (not players[i].vir_infected) then
					local hx, hy, flags
					if (splitscreen) > 1 -- 3+ players
						if (splitscreen) == 2 -- 3 players
							hx, hy, flags = 259, 145, V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_HUDTRANS
						else -- 4 players
							hx, hy, flags = 131, 145, V_SNAPTOBOTTOM|V_HUDTRANS
						end
					else -- 1/2 player(s)
						hx, hy, flags = 265, 129, V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_HUDTRANS
					end
					
					v.draw(hx, hy, v.cachePatch((splitscreen) > 1 and "4PWANTED" or "K_WANTED"), flags, v.getColormap(-1, players[i].skincolor)) --poster
					v.draw(hx+((splitscreen) > 1 and 13 or 8), hy+((splitscreen) > 1 and 16 or 21), v.cachePatch(skins[players[i].mo.skin].facewant), flags, v.getColormap(TC_RAINBOW, players[i].skincolor)) --character icon
					break
				end
			end
		end
		
		if c.pnum == 1 then --Reset Local Viewer table when iterating over Player 1
			vir_localviewers = {}
			vir_localplayerisinfected = false
			vir_localplayerisrunner = false
		end
		table.insert(vir_localviewers,p)
		if p.vir_infected then
			vir_localplayerisinfected = true
		else
			vir_localplayerisrunner = true
		end
		
		if c.pnum == splitscreen+1 then --Draw the following on the last splitscreen player
		
			vir_localteam = 0 --Find out which team is viewing in splitscreen (becomes -1 when both are viewing)
			for i = 0,#vir_localviewers,1 do
				if vir_localviewers[i] and vir_localviewers[i].valid and (not vir_localviewers[i].spectator) then
					if vir_localviewers[i].vir_team > 0 then
						if vir_localteam == 0 then
							vir_localteam = vir_localviewers[i].vir_team
						elseif not (vir_localteam == vir_localviewers[i].vir_team) then
							vir_localteam = -1
							break
						end
					end
				end
			end
		
			--Redrawn minimap for new wanted system and such; Based off of ampersand's streamhud minimap implementation
			if leveltime > 105 then
				if (not vir_hudmem) or (not (vir_hudmem.currentmap == G_BuildMapName(gamemap))) then --Updates whenever the map changes
					vir_hudmem = {}
					vir_hudmem.currentmap = G_BuildMapName(gamemap)
					
					local oob = 32766*FRACUNIT
					vir_hudmem.vex = {
						   top = -oob,
						bottom = oob,
						  left = oob,
						 right = -oob,
					}
					
					local h = vir_hudmem.vex
					for line in lines.iterate do
						local x = line.v1
						h.top = max($, x.y)
						h.bottom = min($, x.y)
						h.left = min($, x.x)
						h.right = max($, x.x)
					end
					for k,v in pairs(h) do h[k] = $/FRACUNIT end
					h.mheight = abs(h.top - h.bottom)
					h.mwidth = abs(h.left - h.right)

					h.xoff = (h.left + h.mwidth/2)*FRACUNIT
					h.yoff = (h.bottom + h.mheight/2)*FRACUNIT
					
					h.cast = function(mmp)
						h.mmp = mmp
						local amw,amh = mmp.width,mmp.height
						h.xscale = FixedDiv(amw, h.mwidth)
						h.yscale = FixedDiv(amh, h.mheight)
						h.zoom = FixedMul(min(h.xscale, h.yscale), FRACUNIT-(FRACUNIT/20))
					end
				end
				
				local mmp = G_BuildMapName(gamemap).."R"
				if v.patchExists(mmp) then
					mmp = v.cachePatch(mmp)
					local vex = vir_hudmem.vex
					vex.cast(mmp)
					
					local splitflags = (splitscreen == 3 and 0) or V_SNAPTORIGHT
					
					local sx,sy = 320-100,34
					if splitscreen then
						if splitscreen == 1 then --2P: Right-centered
							sy = 50
						elseif splitscreen == 2 then --3P: Bottom-right
							sx,sy = 190,100
						else --4P: Centered (TODO: Slightly off-center in 4:3, uh)
							sx,sy = 110,50
						end
					end
					
					local sxf,syf = sx*FRACUNIT,sy*FRACUNIT
					v.drawScaled(sxf,syf,FRACUNIT,mmp,splitflags|V_HUDTRANSHALF)
					
					sx,sy = $1-mmp.leftoffset,$2-mmp.topoffset
					sxf,syf = sx*FRACUNIT,sy*FRACUNIT
					
					local runnersontop = true
					if vir_localplayerisrunner and not vir_localplayerisinfected then
						runnersontop = false
					end
					
					--Player icons layered as such:
					-- Layer 1: Direction indicator for local players
					-- Layer 2: Players that aren't relevant to the local player (Defaults to infected players if both kinds are viewing)
					-- Layer 3: Players that are relevant to the local player
					-- Layer 4: Local players
					local lastplayerdrawn = false
					local lastplayerdata = nil --X, Y, and scale
					for l = 1,4,1 do
						if l == 4 and lastplayerdata then --If a non-local player is last player, draw the reticule underneath the local players
							local patch = v.cachePatch("MMAPWANT")
							local xo,yo = FixedMul(patch.width/2*FRACUNIT, lastplayerdata[3]), FixedMul(patch.height/2*FRACUNIT, lastplayerdata[3])
							v.drawScaled( sxf+lastplayerdata[1]-xo, syf+lastplayerdata[2]-yo, lastplayerdata[3], patch, splitflags|V_HUDTRANS, nil )
							lastplayerdrawn = true
						end
						for i = 0,15,1 do
							if players[i] and players[i].valid and players[i].mo and (not players[i].spectator)
							and ( ((not splitscreen) and (players[i] == p)) or (not players[i].kartstuff[k_hyudorotimer]) or (players[i].kartstuff[k_hyudorotimer] and players[i].kartstuff[k_stealingtimer] and leveltime%2)) then
								
								if ( (l == 1) and VIR_IsLocalPlayer(players[i]) )
								or ( (l == 2) and (not VIR_IsLocalPlayer(players[i])) and ((runnersontop and players[i].vir_infected) or ((not runnersontop) and (not players[i].vir_infected))) )
								or ( (l == 3) and (not VIR_IsLocalPlayer(players[i])) and ((runnersontop and (not players[i].vir_infected)) or ((not runnersontop) and players[i].vir_infected)) )
								or ( (l == 4) and VIR_IsLocalPlayer(players[i]) ) then
									local mo = players[i].mo
								
									local amnumxpos = (FixedMul(mo.x, vex.zoom) - FixedMul(vex.xoff, vex.zoom))
									local amnumypos = -(FixedMul(mo.y, vex.zoom) - FixedMul(vex.yoff, vex.zoom))
									local xx = amnumxpos + ((0 + vex.mmp.width/2)*FRACUNIT)
									local yy = amnumypos + ((0 + vex.mmp.height/2)*FRACUNIT)
									
									local colskin = mo.skin
									local color = mo.color
									
									if l == 1 then --Local direction indicator (Layer 1)
										local scale = (FRACUNIT*2)/3
										for p = 1,#vir_minimapdirectionpatches,1 do
											if v.patchExists(vir_minimapdirectionpatches[p][1]) then
												if vir_minimapdirectionpatches[p][2] < vir_minimapdirectionpatches[p][3] then 
													if mo.angle >= vir_minimapdirectionpatches[p][2] and mo.angle < vir_minimapdirectionpatches[p][3] then
														local patch = v.cachePatch(vir_minimapdirectionpatches[p][1])
														v.drawScaled( sxf+xx, syf+yy, scale, patch, splitflags|V_HUDTRANSHALF, v.getColormap(colskin,  players[i].skincolor) )
														break
													end
												else
													if mo.angle >= vir_minimapdirectionpatches[p][2] or mo.angle < vir_minimapdirectionpatches[p][3] then --angle wraps around
														local patch = v.cachePatch(vir_minimapdirectionpatches[p][1])
														v.drawScaled( sxf+xx, syf+yy, scale, patch, splitflags|V_HUDTRANSHALF, v.getColormap(colskin, players[i].skincolor) )
														break
													end
												end
											else
												break
											end
										end
									else --Player Icon (Layers 2-4)
										local scale = (FRACUNIT*2)/3
										if (not server.vir_teamsenabled) or (vir_localteam == -1) or (not (vir_localteam == players[i].vir_team)) then --Only have players on the opposite team flash in team mode
											if vir_localplayerisrunner and vir_localplayerisinfected then --Flash both colors alternatingly when both types are viewing
												if (leveltime%(TICRATE*2) <= 2) then
													if players[i].vir_infected then
														colskin = TC_BLINK
														color = vir_teamcolors[players[i].vir_team][3]
													end
												elseif (leveltime%TICRATE <= 2) then
													if not players[i].vir_infected then
														colskin = TC_BLINK
														color = vir_teamcolors[players[i].vir_team][4]
													end
												end
											elseif (leveltime%TICRATE <= 2) then --Flash the opposite color if only one type is viewing
												if vir_localplayerisrunner and players[i].vir_infected then
													colskin = TC_BLINK
													color = vir_teamcolors[players[i].vir_team][3]
												elseif vir_localplayerisinfected and (not players[i].vir_infected) then
													colskin = TC_BLINK
													if server.vir_teamsenabled then
														color = vir_teamcolors[players[i].vir_team][4]
													else
														color = SKINCOLOR_CRIMSON
													end
												end
											end
										end
										if l == 4 then
											scale = FRACUNIT
										end
										if server.vir_lastplayermode and not players[i].vir_infected then
											if l == 4 then
												lastplayerdata = {xx,yy,FRACUNIT}
											else
												lastplayerdata = {xx,yy,(FRACUNIT*3)/4}
											end
										end
										
										local pc = v.cachePatch(skins[mo.skin].facemmap)
										local xo,yo = FixedMul(pc.width/2*FRACUNIT, scale), FixedMul(pc.height/2*FRACUNIT, scale)
										v.drawScaled( sxf+xx-xo, syf+yy-yo, scale, pc, splitflags|V_HUDTRANS, v.getColormap(colskin, color) )
									end
								end
							end
						end
					end
					if lastplayerdata and not lastplayerdrawn then --If a local player is last player, draw reticule over local players
						local patch = v.cachePatch("MMAPWANT")
						local xo,yo = FixedMul(patch.width/2*FRACUNIT, lastplayerdata[3]), FixedMul(patch.height/2*FRACUNIT, lastplayerdata[3])
						v.drawScaled( sxf+lastplayerdata[1]-xo, syf+lastplayerdata[2]-yo, lastplayerdata[3], patch, splitflags|V_HUDTRANS, nil )
					end
					
				end
			end
		
			--New display for listing the remaining non-infected players
			if server.vir_infectionstarted and not (server.vir_lastplayermode or server.vir_endinground) then
				local playerhandled = {}
				local playerpatches = {{},{}}
				local patchstyle = "facerank"
				if splitscreen > 1 then --Use minimap faces instead in 3p/4p
					patchstyle = "facemmap"
				end
				
				local activerunners = 0
				local oopsallsplitscreen = true
				for i = 1,#vir_localviewers,1 do
					if not vir_localviewers[i].spectator then
						playerhandled[vir_localviewers[i]] = true
						if not vir_localviewers[i].vir_infected then
							activerunners = activerunners + 1
							if vir_localviewers[i].mo then
								local colormap
								if (splitscreen > 1) and (leveltime%70 < 6) then --the local player's small icon will flash yellow 
									colormap = v.getColormap(TC_RAINBOW, SKINCOLOR_SUPER1+ (((leveltime%70)/2)*2) )
								else
									if (vir_localviewers[i].mo.colorized) then
										colormap = v.getColormap(TC_RAINBOW, vir_localviewers[i].skincolor)
									else
										colormap = v.getColormap(-1, vir_localviewers[i].skincolor)
									end
								end
								local patch = v.cachePatch(skins[vir_localviewers[i].mo.skin][patchstyle])
								local spinningout = vir_localviewers[i].kartstuff[k_spinouttimer] or vir_localviewers[i].kartstuff[k_wipeoutslow]
								local usinghyudoro = vir_localviewers[i].kartstuff[k_hyudorotimer] > 0
								if ((not server.vir_teamsenabled) and (#playerpatches[1] <= #playerpatches[2])) or (vir_localviewers[i].vir_team == 1) then
									table.insert(playerpatches[1],{patch,colormap,true,spinningout,usinghyudoro})
								elseif (not server.vir_teamsenabled) or vir_localviewers[i].vir_team == 2 then
									table.insert(playerpatches[2],{patch,colormap,true,spinningout,usinghyudoro})
								end
							end
						end
					end
				end
				for i = 0,15,1 do
					if players[i] and players[i].valid and (not players[i].spectator) and (not playerhandled[players[i]]) then
						oopsallsplitscreen = false
						if not players[i].vir_infected then
							activerunners = activerunners + 1
							if players[i].mo then
								local usinghyudoro = players[i].kartstuff[k_hyudorotimer] > 0
								if (not usinghyudoro) or ((vir_localteam > 0) and (players[i].vir_team == vir_localteam)) then --other players with hyudoro will be hidden here too, unless they're on the same team
									local colormap
									if (players[i].mo.colorized) then
										colormap = v.getColormap(TC_RAINBOW, players[i].skincolor)
									else
										colormap = v.getColormap(-1, players[i].skincolor)
									end
									local patch = v.cachePatch(skins[players[i].mo.skin][patchstyle])
									local spinningout = players[i].kartstuff[k_spinouttimer] or players[i].kartstuff[k_wipeoutslow]
									if ((not server.vir_teamsenabled) and (#playerpatches[1] <= #playerpatches[2])) or (players[i].vir_team == 1) then
										table.insert(playerpatches[1],{patch,colormap,false,spinningout,usinghyudoro})
									elseif (not server.vir_teamsenabled) or players[i].vir_team == 2 then
										table.insert(playerpatches[2],{patch,colormap,false,spinningout,usinghyudoro})
									end
								end
							end
						end
					end
				end
				
				if vir_debug then
					local count = 2
					for i = 2,8,1 do
						for a = 1,2,1 do
							count = count + 1
							if count > leveltime/175 then
								break 2
							end
							if (playerpatches[a][i] == nil) and playerpatches[a][1] then
								playerpatches[a][i] = playerpatches[a][1]
								playerpatches[a][i][3] = false
							end
						end
					end
				end
				
				if splitscreen == 3 and ((#playerpatches[1] > 3) or (#playerpatches[2] > 3)) then
					local newpatchgroup = {{},{},{},{}}
					if server.vir_teamsenabled then
						for a = 1,2,1 do
							if #playerpatches[a] > 3 then
								local index = 1
								for b = 1,#playerpatches[a],1 do
									table.insert(newpatchgroup[index+((a-1)*2)],playerpatches[a][b])
									index = index + 1
									if index > 2 then
										index = 1
									end
								end
							else
								for b = 1,#playerpatches[a],1 do
									table.insert(newpatchgroup[a+1],playerpatches[a][b])
								end
							end
						end
					else
						local index = 1
						for b = 1,8,1 do
							for a = 1,2,1 do
								if playerpatches[a][b] then
									table.insert(newpatchgroup[index],playerpatches[a][b])
									index = index + 1
									if index > 4 then
										index = 1
									end
								else
									break
								end
							end
						end
					end
					playerpatches = newpatchgroup
				elseif splitscreen == 1 and (#playerpatches[1] == 1) and (#playerpatches[2] == 1) then
					playerpatches[1][2] = playerpatches[1][1]
					playerpatches[1][1] = playerpatches[2][1]
					playerpatches[2] = {}
				end
				
				if (not oopsallsplitscreen) and activerunners > 1 then --Don't show element when all players involved are shown via splitscreen (or when only 1 runner remains)
					local patchalign = V_SNAPTOLEFT
					local face_x = 13
					local face_y = 70
					local columnoffset = 18
					local rowoffsets = {18,18}
					local patchlimit = 5
					
					local vertical = true
					if not splitscreen then --1P
						v.drawString(30, 60, "LEFT", V_HUDTRANS|V_PURPLEMAP, "center")
					elseif splitscreen == 1 then --2P
						v.drawString(317, 154, "LEFT", V_HUDTRANS|V_PURPLEMAP, "right")
						patchalign = V_SNAPTORIGHT
						face_x = 302
						face_y = 164
						vertical = false
					elseif splitscreen > 1 then
						rowoffsets = {13,13,13,13}
						if splitscreen == 2 then --3P
							v.drawString(165, 102, "LEFT", V_HUDTRANS|V_PURPLEMAP, "thin")
							columnoffset = 13
							face_x = 162
							face_y = 112
							patchalign = V_SNAPTORIGHT
							patchlimit = 6
						else --4P
							v.drawString(150, 143, "LEFT", V_HUDTRANS|V_PURPLEMAP, "thin")
							columnoffset = 14
							face_x = 147
							face_y = 153
							patchlimit = 3
							if #playerpatches > 2 then
								face_x = face_x - columnoffset
							end
						end
					end
					
					for i = 1,#playerpatches,1 do
						if #playerpatches[i] > patchlimit then
							rowoffsets[i] = FixedCeil(((patchlimit*rowoffsets[i])*FRACUNIT)/(#playerpatches[i]))/FRACUNIT
						elseif #playerpatches > 2 --4P with more than 3 patches on one side
							if #playerpatches[i] == 0 then
								if i > 2 then
									face_x = face_x + (columnoffset/2)
								else
									face_x = face_x - (columnoffset/2)
								end
							end
						elseif #playerpatches[i] == 0 then
							if vertical then
								face_x = face_x + (columnoffset/2)
							end
							columnoffset = 0
						end
					end
					
					local playershandled = 0 --To offset the shaking effect
					
					for a = 1,#playerpatches,1 do
						local curr_face_x = face_x + (columnoffset * (a-1))
						local curr_face_y = face_y + (rowoffsets[a]*(#playerpatches[a]-1))
						if vertical then
							curr_face_x = face_x + (columnoffset * (a-1))
							curr_face_y = face_y + (rowoffsets[a]*(#playerpatches[a]-1))
						else
							curr_face_x = face_x - (rowoffsets[a]*(#playerpatches[a]-1))
							curr_face_y = face_y + (columnoffset * (a-1))
						end
						for i = #playerpatches[a],1,-1 do
							playershandled = playershandled + 1
							local xmod = 0
							local ymod = 0
							if playerpatches[a][i][4] then
								xmod = (((leveltime/2)+playershandled)%4) - 1
								if xmod > 1 then
									xmod = 0 --2 - xmod
								end
								if not vertical then
									ymod = xmod
									xmod = 0
								end
							end
							v.draw(curr_face_x+xmod, curr_face_y+ymod, playerpatches[a][i][1], (playerpatches[a][i][5] and V_HUDTRANSHALF or V_HUDTRANS)|patchalign, playerpatches[a][i][2])
							if playerpatches[a][i][3] and splitscreen <= 1 then
								local patch = v.cachePatch(vir_facehighlightpatchnames[((leveltime/4)%8)+1])
								v.draw(curr_face_x+xmod, curr_face_y+ymod, patch, V_HUDTRANS|patchalign)
							end
							if vertical then
								curr_face_y = curr_face_y - rowoffsets[a]
							else
								curr_face_x = curr_face_x + rowoffsets[a]
							end
						end
					end
				end
			end
		end
	end
end)

local vir_helditemdrops = {} --MOBJ to drop, is orbital, drop all
vir_helditemdrops[MT_ORBINAUT_SHIELD] = {MT_ORBINAUT,true,true}
vir_helditemdrops[MT_JAWZ_SHIELD] = {MT_JAWZ_DUD,true,true}
vir_helditemdrops[MT_BANANA_SHIELD] = {MT_BANANA,false,true}
vir_helditemdrops[MT_SSMINE] = {MT_SSMINE_SHIELD,false,false}
vir_helditemdrops[MT_EGGMANITEM_SHIELD] = {MT_EGGMANITEM,false,true}

local VIR_DropHeldItems =
	function(player)
		--print("Dropping player's held items")
		if player and player.mo and player.mo.hnext then
			--print(" item found")
			local ponground = P_IsObjectOnGround(player.mo)
			local flip = P_MobjFlip(player.mo)
			local nextmobj
			local currentmobj = player.mo.hnext
			for i = 1,10,1 do
				--print("  Item "..i)
				if currentmobj and vir_helditemdrops[currentmobj.type] then
					--print("   is valid")
					nextmobj = currentmobj.hnext
					local mobjtype = vir_helditemdrops[currentmobj.type][1]
					local orbital = vir_helditemdrops[currentmobj.type][2]
					local dropall = vir_helditemdrops[currentmobj.type][3]
					
					local droppedmobj = P_SpawnMobj(currentmobj.x, currentmobj.y, currentmobj.z, mobjtype)
					droppedmobj.target = player.mo
					droppedmobj.angle = currentmobj.angle
					droppedmobj.flags2 = currentmobj.flags2
					droppedmobj.flags = $|MF_NOCLIPTHING
					--droppedmobj.floorz = currentmobj.floorz
					--droppedmobj.ceilingz = currentmobj.ceilingz
					if ponground then
						if flip == 1 then
							if (currentmobj.floorz > droppedmobj.target.z - droppedmobj.height) then
								P_TeleportMove(droppedmobj, droppedmobj.x, droppedmobj.y, currentmobj.floorz)
							end
						else
							if (currentmobj.ceilingz < droppedmobj.target.z + droppedmobj.target.height + droppedmobj.height) then
								P_TeleportMove(droppedmobj, droppedmobj.x, droppedmobj.y, currentmobj.ceilingz - droppedmobj.height)
							end
						end
					end
					
					if orbital then
						--print("    orbital")
						droppedmobj.flags2 = $|MF2_AMBUSH
						droppedmobj.z = droppedmobj.z + flip
						droppedmobj.momx = player.mo.momx>>1
						droppedmobj.momy = player.mo.momy>>1
						droppedmobj.momz = 3*flip*mapobjectscale
						if (droppedmobj.eflags & MFE_UNDERWATER) then
							droppedmobj.momz = (117 * droppedmobj.momz) / 200
						end
						P_Thrust(droppedmobj, currentmobj.angle - ANGLE_90, 6*mapobjectscale)
						droppedmobj.movecount = 2
						droppedmobj.movedir = currentmobj.angle - ANGLE_90
						droppedmobj.state = droppedmobj.info.deathstate
						droppedmobj.tics = -1
						if (mobjtype == MT_JAWZ_DUD)
							droppedmobj.z = droppedmobj.z + (20*flip*droppedmobj.scale)
						else
							droppedmobj.color = currentmobj.color
							droppedmobj.angle = droppedmobj.angle - ANGLE_90
						end
					else
						--print("    trailing")
						droppedmobj.flags = $ & ~MF_NOCLIPTHING
						droppedmobj.threshold = 10
					end
					P_KillMobj(currentmobj)
					--print("   original mobj killed")
					if mobjtype == MT_EGGMANITEM then --Unneeded now?
						break
					end
					currentmobj = nextmobj
				else
					break
				end
			end
			--("DONE")
			player.mo.hnext = nil
			player.kartstuff[k_bananadrag] = 0
			player.kartstuff[k_eggmanheld] = 0
			player.kartstuff[k_itemheld] = 0
			player.kartstuff[k_itemamount] = 0
			player.kartstuff[k_itemtype] = KITEM_NONE
		end
	end

local VIR_DropItems =
	function(player)
		VIR_DropHeldItems(player)
		if vir_itemdoesntdrop[player.kartstuff[k_itemtype]] then
			--K_DropHnextList(player)
			K_StripItems(player)
		else
			K_DropItems(player)
		end
	end

local vir_items = --First group: Left 5 are for non-infected, Right 5 (+1) are for infected; Second group: Item type and amount
{
	{ {0, 1, 1, 1, 2,  1, 2, 2, 2, 2,  1} , {KITEM_SNEAKER,1}			}, -- Sneaker
	{ {0, 0, 0, 0, 0,  0, 0, 0, 0, 0,  0} , {KITEM_SAD,1}					}, -- Rocket Sneaker
	{ {0, 0, 0, 0, 0,  0, 0, 0, 0, 0,  3} , {KITEM_INVINCIBILITY,1}		}, -- Invincibility
	{ {2, 1, 1, 1, 0,  2, 1, 1, 0, 0,  0} , {KITEM_BANANA,1}			 	}, -- Banana
	{ {0, 0, 0, 0, 0,  0, 1, 1, 1, 2,  0} , {KITEM_EGGMAN,1}			}, -- Eggman
	{ {6, 4, 2, 1, 1,  6, 4, 2, 1, 1,  0} , {KITEM_ORBINAUT,1}		 	}, -- Orbinaut
	{ {1, 1, 1, 2, 2,  1, 1, 1, 2, 2,  0} , {KITEM_JAWZ,1}				 	}, -- Jawz
	{ {1, 1, 1, 0, 0,  1, 1, 0, 0, 0,  0} , {KITEM_MINE,1}					}, -- Mine
	{ {0, 1, 1, 2, 2,  0, 1, 2, 2, 2,  2} , {KITEM_BALLHOG,1}			}, -- Ballhog
	{ {0, 0, 0, 0, 0,  0, 0, 0, 0, 0,  0} , {KITEM_SPB,1}					}, -- S.P.B.
	{ {0, 0, 0, 0, 0,  0, 0, 0, 0, 0,  0} , {KITEM_SAD,1}					}, -- Growth
	{ {0, 0, 0, 0, 0,  0, 0, 0, 0, 0,  0} , {KITEM_SAD,1}					}, -- Shrink
	{ {0, 1, 1, 1, 1,  0, 0, 0, 0, 0,  0} , {KITEM_THUNDERSHIELD,1}	}, -- Thunder Shield
	{ {0, 1, 1, 1, 1,  0, 0, 0, 0, 0,  0} , {KITEM_HYUDORO,1}			}, -- Hyudoro
	{ {1, 2, 2, 2, 2,  1, 1, 1, 1, 1,  1} , {KITEM_POGOSPRING,1}		}, -- Pogo Spring
	{ {0, 0, 0, 0, 0,  0, 0, 0, 0, 0,  0} , {KITEM_SAD,1}					}, -- Kitchen Sink
	{ {0, 0, 0, 1, 1,  0, 0, 0, 1, 1,  3} , {KITEM_SNEAKER,3}			}, -- Sneaker x3
	{ {0, 1, 1, 2, 2,  0, 0, 0, 0, 0,  0} , {KITEM_BANANA,3}				}, -- Banana x3
	{ {0, 0, 0, 1, 1,  0, 0, 0, 0, 0,  0} , {KITEM_BANANA,10}			}, -- Banana x10
	{ {0, 0, 1, 1, 2,  0, 0, 1, 1, 2,  0} , {KITEM_ORBINAUT,3}			}, -- Orbinaut x3
	{ {0, 0, 0, 1, 1,  0, 0, 0, 1, 1,  1} , {KITEM_ORBINAUT,4}			}, -- Orbinaut x4
	{ {0, 0, 0, 1, 2,  0, 0, 1, 1, 2,  3} , {KITEM_JAWZ,2}					}	-- Jawz x2
}

local VIR_GiveRouletteItem =
	function(playerindex)
		local player = players[playerindex]
		if player and player.valid then
			local spawnchance = {}
			local totalspawnchance = 0
		
			local eggboxcount = server.vir_eggboxesinplay
			local playercount = 0 --count of valid players
			local comparecount = 0 --count of players being compared
			local oppositecount = 0 --count of players on the opposite side
			for i = 0,15,1 do
				if players[i] and players[i].valid and (not players[i].spectator) then
					playercount = playercount + 1
					if server.vir_teamsenabled then --Red runners compared to Blue runners (Infected ignored)
						if (not players[i].vir_infected) then
							comparecount = comparecount + 1
							if not (players[i].vir_team == player.vir_team) then
								oppositecount = oppositecount + 1
							end
						end
					else --Infected count compared to Runner count
						comparecount = comparecount + 1
						if (player.vir_infected and (not players[i].vir_infected)) or ((not player.vir_infected) and players[i].vir_infected) then
							oppositecount = oppositecount + 1
						end
					end
					if player.kartstuff[k_itemtype] == KITEM_EGGMAN and player.kartstuff[k_itemamount] then
						eggboxcount = eggboxcount + 1
					end
				end
			end
			
			local roulettestop = TICRATE + (3*(comparecount - oppositecount))
			local mashed = 0
			
			if player.kartstuff[k_itemblinkmode] == 1 then
				mashed = FixedDiv(player.vir_itemroulette*FRACUNIT, ((TICRATE*3)+roulettestop)*FRACUNIT) - FRACUNIT
			end
			
			local ranking = min(5,((((oppositecount*FRACUNIT)/comparecount)*4)/FRACUNIT)+1) --Ranking here is based off of how many players remain on the opposite "team"
			if player.vir_infected then
				if (playercount > 2) and (oppositecount+1 >= playercount) and (leveltime >= (vir_starttime + 30*TICRATE)) then --Ensure that a singular infected gets better items if they're having trouble getting anyone
					if (leveltime >= (vir_starttime + 60*TICRATE)) then --After 60 seconds you get power items (mainly dual jawz, triple sneakers, and invincibility)
						ranking = 11
					else --But at only 30+ seconds it just ensures you get rank 5 items
						ranking = 10
					end
				else --Move ranking over onto the infected side of the table
					ranking = ranking + 5
				end
			elseif server.vir_lastplayermode then --The last non-infected player gets high-end items
				ranking = 5
				player.kartstuff[k_roulettetype] = 1
			end

			for i = 1,22,1 do
				if (i == 3 and player.kartstuff[k_invincibilitytimer]) --Invincibility
				or (i == 5 and (player.kartstuff[k_eggmanheld] or (eggboxcount >= max(4,playercount/2))) ) --Eggman Item
				or (i == 13 and (server.vir_lastplayermode or server.vir_playerwithshield >= 0)) --Thunder Shield
				or (i == 14 and (server.vir_lastplayermode or (leveltime < server.vir_hyudorocooldown))) then --Hyudoro
					spawnchance[i] = 0
				else
					spawnchance[i] = vir_items[i][1][ranking]
				end
				
				if spawnchance[i] then
					spawnchance[i] = (((spawnchance[i]*FRACUNIT)+mashed)*4)/FRACUNIT
					totalspawnchance = totalspawnchance + spawnchance[i]
				end
			end
			
			if server.vir_spbtarget and (not server.vir_spbinplay) and player.vir_infected then --Add a flat chance of an SPB when there's a valid target
				if (not server.vir_teamsenabled) or (not (player.vir_team == server.vir_spbtarget.vir_team)) then --Check if player is on the other team in team mode
					spawnchance[10] = totalspawnchance / 3
					totalspawnchance = totalspawnchance + spawnchance[10]
				end
			end
			
			if totalspawnchance > 0 then
				local index = P_RandomRange(1,totalspawnchance)
				for i = 1,22,1 do
					if spawnchance[i] then
						if index <= spawnchance[i] then
							player.kartstuff[k_itemtype] = vir_items[i][2][1]
							player.kartstuff[k_itemamount] = vir_items[i][2][2]
							if i == 10 then --SPB
								server.vir_spbinplay = true
								server.vir_playerwithspb = playerindex
							elseif i == 13 then --Thunder Shield
								server.vir_playerwithshield = playerindex
								player.vir_autouseshieldtime = leveltime + vir_shieldtime
							elseif i == 14 then --Hyudoro
								server.vir_hyudorocooldown = leveltime + (5*TICRATE)
							end
							break
						else
							index = index - spawnchance[i]
						end
					end
				end
			else
				player.kartstuff[k_itemtype] = KITEM_SAD
				player.kartstuff[k_itemamount] = 1
			end
		end
	end
	
local VIR_DoThunderShield = --Almost entirely copied from source code
	function(player)
		S_StartSound(player.mo, sfx_zio3)
		--player.kartstuff[k_thunderanim] = 35
		P_NukeEnemies(player.mo, player.mo, RING_DIST/4)

		-- spawn vertical bolt
		local mo = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
		mo.target = player.mo
		mo.state = S_LZIO11
		mo.color = SKINCOLOR_TEAL
		mo.scale = player.mo.scale*3 + (player.mo.scale/2)

		mo = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
		mo.target = player.mo
		mo.state = S_LZIO21
		mo.color = SKINCOLOR_CYAN
		mo.scale = player.mo.scale*3 + (player.mo.scale/2)

		-- spawn horizontal bolts
		for i = 0,7,1 do--(i=0; i<7; i++)
			mo = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
			mo.angle = P_RandomRange(0, 359)*ANG1
			mo.fuse = P_RandomRange(20, 50)
			mo.target = player.mo
			mo.state = S_KLIT1
		end

		-- spawn the radius thing:
		local an = ANGLE_22h
		for i = 0,15,1 do	--for (i=0; i<15; i++)
			local sx = player.mo.x + FixedMul((player.mo.scale*vir_thunderradius), cos((an*i)>>vir_angletofineshift))
			local sy = player.mo.y + FixedMul((player.mo.scale*vir_thunderradius), sin((an*i)>>vir_angletofineshift))
			mo = P_SpawnMobj(sx, sy, player.mo.z, MT_THOK)
			mo.angle = an*i
			mo.extravalue1 = vir_thunderradius -- Used to know whether we should teleport by radius or something.
			mo.scale = player.mo.scale*3
			mo.target = player.mo
			mo.state = S_KSPARK1
		end
		
		player.kartstuff[k_itemamount] = 0
		player.kartstuff[k_itemtype] = KITEM_NONE
		player.kartstuff[k_curshield] = 0
		player.vir_usingshield = true
	end

local VIR_EndBattle =
	function()
		if not server.vir_endinground then
			server.vir_endinground = true
			local resetinitialselector = true
			local allinfected = {true,true}
			local highscore = 0
			for i = 0,15,1 do --resets smart selector when all active players have been initial infected at least once, starting over with this round's initial infected
				if players[i] and players[i].valid and (not players[i].spectator) then
					if not (server.vir_playerhasbeeninitial[i] or players[i].vir_initialinfected) then
						resetinitialselector = false
					end
					if server.vir_teamsenabled then
						if not players[i].vir_infected then
							allinfected[players[i].vir_team] = false
						end
						if players[i].marescore > highscore then
							highscore = players[i].marescore
						end
					elseif server.vir_lastplayermode and not players[i].vir_infected then
						print(players[i].name.." has avoided infection!")
						allinfected[1] = false
					end
				end
			end
			local winningteam = 0
			if server.vir_teamsenabled then
				if allinfected[1] and allinfected[2] then
					print("\131All players have been infecte-!\128 Wait, what?")
				elseif allinfected[1] then
					print("Red Team has been fully infected!\n\132Blue Team is the winner!")
					winningteam = 2
				elseif allinfected[2] then
					print("Blue Team has been fully infected!\n\133Red Team is the winner!")
					winningteam = 1
				end
			elseif allinfected[1] then
				print("\131All players have been infected!")
			end
			for i = 0,15,1 do --mark players as exiting
				if players[i] and players[i].valid then
					if server.vir_teamsenabled then
						if allinfected[players[i].vir_team] then
							players[i].marescore = 0
						else
							players[i].marescore = highscore
						end
					end
					players[i].exiting = 281
					if players[i].vir_initialinfected then
						players[i].vir_recentlybeeninitial = true
						server.vir_playerhasbeeninitial[i] = true
					else
						players[i].vir_recentlybeeninitial = false
						if resetinitialselector then
							server.vir_playerhasbeeninitial[i] = false
						end
					end
				end
			end
			if resetinitialselector then
				server.vir_playerleftafterinitial = {}
			end
			for i = 0,15,1 do --apply ending music
				if players[i] and players[i].valid and (not players[i].spectator) then
					if server.vir_teamsenabled then
						if winningteam == 0 then
							S_ChangeMusic("kbok", false, players[i])
						else
							if players[i].vir_team == winningteam then
								S_ChangeMusic("kbwin", false, players[i])
							else
								S_ChangeMusic("kblose", false, players[i])
							end
						end
					else
						if players[i].kartstuff[k_position] == 1
							S_ChangeMusic("kbwin", false, players[i])
						else
							if K_IsPlayerLosing(players[i])
								S_ChangeMusic("kblose", false, players[i])
							else
								S_ChangeMusic("kbok", false, players[i])
							end
						end
					end
				end
			end
		end
	end

--Make sure any player with a green color shows up as a lighter green in Hitfeed
local vir_greencolors = {SKINCOLOR_LIME, SKINCOLOR_HANDHELD, SKINCOLOR_MOSS, SKINCOLOR_CAMOUFLAGE, SKINCOLOR_ROBOHOOD, SKINCOLOR_MINT, SKINCOLOR_GREEN, SKINCOLOR_PINETREE, SKINCOLOR_EMERALD, SKINCOLOR_SWAMP, SKINCOLOR_DREAM, SKINCOLOR_PLAGUE, SKINCOLOR_ALGAE}
local vir_isgreencolor = {}
for i = 1,#vir_greencolors,1 do
	vir_isgreencolor[vir_greencolors[i]] = true
end
	
local VIR_HitfeedMessage =
	function(inflictor,target,patch)
		if hitfeed then
			if not HF_animIcon["K_VRHIT"] then
				HF_animIcon["K_VRHIT"] = vir_hitfeediconanim
			end
			if HF_ReturnConsolePlayer then --V1.1
				if inflictor == nil then
					inflictor = target
				end
				HF_SendHitMessage(inflictor, target, patch)
			else --V2
				local tabledata
				if inflictor == target then
					tabledata = { {{},{}} , {{},{},target} }
				else
					tabledata = { {{},{},inflictor} , {{},{},target} }
				end
				for i = 1,2,1 do
					if tabledata[i][3] and tabledata[i][3].valid then
						local player = tabledata[i][3]
						local team = player.vir_team
						local iconcolor
						local textcolor
						if player.vir_infected and player.vir_infected < leveltime then
							iconcolor = vir_teamcolors[team][2]
							textcolor = vir_teamcolors[team][3]
						elseif server.vir_teamsenabled and not player.vir_infected then
							iconcolor = vir_teamcolors[team][1]
							textcolor = vir_teamcolors[team][4]
						elseif vir_isgreencolor[player.skincolor] then
							iconcolor = SKINCOLOR_TEA
							textcolor = SKINCOLOR_TEA
						else
							iconcolor = player.skincolor
							textcolor = player.skincolor
						end
						tabledata[i] = { {player.name,textcolor} , {skins[player.mo.skin].facemmap,iconcolor} , player }
					else
						tabledata[i] = {{},{}}
					end
				end
				HF_SendHitMessage(tabledata[1], tabledata[2], patch)
			end
		end
	end
	
local VIR_AttemptInfection = --Check if infection is possible, and if so infect the player (mo) and cause them to wipeout
	function(mo,inflictor)
		if abs(mo.z - inflictor.z) <= P_GetPlayerHeight(inflictor.player) and not mo.player.kartstuff[k_hyudorotimer] and not mo.player.vir_usingshield then
			local teamattack = server.vir_teamsenabled and (mo.player.vir_team == inflictor.player.vir_team)
			if inflictor.player.vir_caninfect and (not (mo.player.kartstuff[k_pogospring] or mo.player.kartstuff[k_sneakertimer]))
			and ((not teamattack) or (not (mo.player.kartstuff[k_spinouttimer] or mo.player.kartstuff[k_wipeoutslow] or mo.player.kartstuff[k_squishedtimer] or mo.player.powers[pw_flashing]))) then
				mo.player.kartstuff[k_spinouttype] = 1
				mo.player.kartstuff[k_spinouttimer] = (3*TICRATE/2)+2
				mo.player.kartstuff[k_driftboost] = 0
				mo.player.kartstuff[k_drift] = 0
				mo.player.kartstuff[k_driftcharge] = 0
				mo.player.kartstuff[k_pogospring] = 0
				mo.player.kartstuff[k_instashield] = 15
				if (mo.player.kartstuff[k_itemtype] == KITEM_THUNDERSHIELD and mo.player.kartstuff[k_itemamount]) then --Thunder Shield prevents infection, but still spins out
					VIR_HitfeedMessage(inflictor.player, mo.player, "K_VRRAM")
					VIR_DoThunderShield(mo.player)
				else
					VIR_DropHeldItems(mo.player)
					S_StartSound(mo, sfx_slip) --TODO: Maybe replace this with a custom sound later? (Currently spinout sound while its actually a wipeout)
					if teamattack then
						VIR_HitfeedMessage(inflictor.player, mo.player, "K_VRRAM")
					else
						K_PlayHitEmSound(inflictor)
						server.vir_lastinfecttime = leveltime
						mo.player.vir_infected = leveltime
						print(vir_teamtextcolor[mo.player.vir_team]..mo.player.name.."\x80 infected!")
						VIR_HitfeedMessage(inflictor.player, mo.player, "K_VRHIT")
					end
				end
				return true
			else
				K_DoInstashield(mo.player)
			end
		end
		return false
	end
	
local VIR_TakeDamage = --Damage the player's internal health and infect them if it drops to 0
	function(player,dmg)
		if not player.vir_infected and server.vir_infectionstarted then
			player.vir_health = player.vir_health - dmg
			if player.vir_health <= 0 then
				server.vir_lastinfecttime = leveltime
				player.vir_infected = leveltime
				print(vir_teamtextcolor[player.vir_team]..player.name.."\x80 infected!")
				if dmg == 1 then
					VIR_HitfeedMessage(nil, player, "K_VRHIT")
				end
			end
		end
	end
	
local VIR_RemoveItem = --Removes the item on the player from play entirely via hyudoro (generally for infected players)
	function(player)
		player.kartstuff[k_stolentimer] = TICRATE/2
		player.kartstuff[k_itemtype] = KITEM_NONE
		player.kartstuff[k_itemamount] = 0
		player.kartstuff[k_itemheld] = 0
		if VIR_IsLocalPlayer(player) then
			S_StartSound(nil,sfx_s3k92)
		end
	end
	
local VIR_SelectInfected =
	function(team,validplayers,allteamplayers,excludeplayer)
		local teamplayers = {}
		for i = 1,#validplayers,1 do
			if (team == 0 or validplayers[i].vir_team == team) and (not ((validplayers[i] == excludeplayer) or validplayers[i].vir_recentlybeeninitial)) then
				table.insert(teamplayers,validplayers[i])
			end
		end
		if #teamplayers <= 0 then
			teamplayers = allteamplayers
		end
		if #teamplayers > 0 then
			local infectplayerindex = P_RandomRange(1,#teamplayers) --The initial infected player is given a very specific number of the NONE item, which should be picked up on the next frame (for replay syncing)
			local infectedplayer = teamplayers[infectplayerindex]
			infectedplayer.vir_preserveditemtype = infectedplayer.kartstuff[k_itemtype]
			infectedplayer.vir_preserveditemcount = infectedplayer.kartstuff[k_itemamount]
			infectedplayer.kartstuff[k_itemtype] = KITEM_NONE
			infectedplayer.kartstuff[k_itemamount] = 55
			for i = 0,15,1 do --Ensure that no item roulettes resolve on the next frame (prooobably won't account for mashing, so it'd probably only happen if you received an item the frame the countdown ends)
				if players[i] and players[i].valid and (not players[i].spectator) then
					players[i].kartstuff[k_itemroulette] = min(players[i].kartstuff[k_itemroulette],(TICRATE*3)-2)
				end
			end
			return infectedplayer
		else
			VIR_EndBattle() --End round if somehow there's nobody on a team
		end
	end

addHook("ThinkFrame", do
	if not server.vir_enabled then return end
	if leveltime > 2 then
		local runningplayers = {} --non-infected players
		local validplayers = {} --players that can be chosen as initial (for smart selector)
		local infectedplayers = {} --players that are down with the sickness
		local teamplayers = {{{},{}},{{},{}}} --Red players (runners/infected), Blue players (runners/infected)
		local newscore = nil
		if (not server.vir_endinground) and leveltime >= (server.vir_lastscoreupdate + TICRATE) then --Increase score every second after infection starts
			newscore = (leveltime - vir_starttime) / TICRATE
			server.vir_lastscoreupdate = leveltime
		end
		local longestidletime = 0
		local longestidler = nil
		local initialinfectednames = {}
		for i = 0,15,1 do
			if players[i] and players[i].valid then
				if server.vir_playernames[i] then
					if not (server.vir_playernames[i] == players[i].name) then
						server.vir_playernames[i] = players[i].name
					end
				else --Player joined after mapload
					VIR_ResetPlayerData(i)
					hud.disable("minimap")
					hud.disable("gametypeinfo")
					hud.disable("battlerankingsbumpers")
					hud.disable("wanted")
					hud.disable("minirankings")
				end
				if players[i].spectator then --Spectators will be marked as infected if they manage to join midgame
					if leveltime > vir_starttime then
						players[i].vir_wasspectating = true
					end
				else
					if server.vir_teamsenabled then --In team mode, ensure the player has a team and apply team color
						if players[i].vir_team == 0 then
							local teamcounts = {0,0}
							for t = 0,15,1 do
								if players[t] and players[t].valid and (not players[t].spectator) and players[t].vir_team then
									teamcounts[players[t].vir_team] = teamcounts[players[t].vir_team] + 1
								end
							end
							if teamcounts[1] < teamcounts[2] then
								players[i].vir_team = 1
							elseif teamcounts[2] < teamcounts[1] then
								players[i].vir_team = 2
							else
								local seed = (server.vir_rngseed + leveltime) / 3
								players[i].vir_team = (seed%2)+1
							end
						end
						for c = 1,2,1 do
							if (players[i].vir_team == c) and (not (players[i].skincolor == vir_teamcolors[c][1])) then
								if server.vir_playerprefcolors == nil then
									server.vir_playerprefcolors = {}
								end
								server.vir_playerprefcolors[i] = players[i].skincolor
								players[i].skincolor = vir_teamcolors[c][1]
								if players[i].mo then
									players[i].mo.color = vir_teamcolors[c][1]
								end
								break
							end
						end
					end
					if players[i].vir_wasspectating and not players[i].vir_infected then --Joining players will have no influence on Last Player mode's timer
						players[i].vir_wasspectating = false
						if server.vir_infectionstarted then
							players[i].vir_infected = leveltime
							players[i].marescore = 0
							print(vir_teamtextcolor[players[i].vir_team]..players[i].name.."\x80 infected!")
						end
					end
					if players[i].kartstuff[k_itemtype] == KITEM_NONE and players[i].kartstuff[k_itemamount] == 55 then --Infect the player if 55 NONE items are detected on the player (for replay syncing)
						players[i].vir_infected = leveltime
						if server.vir_infectionstarted then
							server.vir_lastinfecttime = leveltime
						else
							players[i].vir_initialinfected = true
							server.vir_lastinfecttime = leveltime + 25*TICRATE --Last Player mode is delayed if there's only 2 players in the match (should total 30 seconds of delay)
						end
						players[i].kartstuff[k_itemtype] = players[i].vir_preserveditemtype
						players[i].kartstuff[k_itemamount] = players[i].vir_preserveditemcount
						table.insert(initialinfectednames,vir_teamtextcolor[players[i].vir_team]..players[i].name)
						VIR_HitfeedMessage(nil, players[i], "K_VRHIT")
					elseif players[i].kartstuff[k_itemtype] == KITEM_SPB and ((not server.vir_spbtarget) or (server.vir_teamsenabled and (players[i].vir_team == server.vir_spbtarget.vir_team))) then --Confiscate the SPB if the intended target gets infected or leaves (or ends up on the same team)
						VIR_RemoveItem(players[i])
						server.vir_spbinplay = false
					end
					if not players[i].vir_falling then --Players that fall too many times will become infected
						if players[i].health == 0 then
							players[i].vir_falling = true
							if players[i].kartstuff[k_itemtype] == KITEM_THUNDERSHIELD and players[i].kartstuff[k_itemamount] then --Consume Thunder Shield if the player has one when falling
								players[i].kartstuff[k_itemtype] = KITEM_NONE
								players[i].kartstuff[k_itemamount] = 0
							else --Otherwise take damage
								VIR_TakeDamage(players[i],1)
							end
						end
					elseif not (players[i].health == 0) then
						players[i].vir_falling = false
					end
					
					if leveltime >= vir_starttime then
						if players[i].vir_infected then
							table.insert(infectedplayers,players[i])
							if server.vir_teamsenabled and players[i].vir_team then
								table.insert(teamplayers[players[i].vir_team][2],players[i])
							end
							if players[i].kartstuff[k_sneakertimer] or players[i].kartstuff[k_pogospring] or players[i].kartstuff[k_invincibilitytimer] then
								players[i].powers[pw_flashing] = 0
							end
							if players[i].kartstuff[k_spinouttimer] or players[i].kartstuff[k_wipeoutslow] or players[i].kartstuff[k_squishedtimer] or players[i].powers[pw_flashing] then
								players[i].vir_caninfect = false
							else
								players[i].vir_caninfect = true
							end
							players[i].kartstuff[k_bumper] = 2
							players[i].kartstuff[k_wanted] = 0
							players[i].vir_health = 0
						else
							table.insert(runningplayers,players[i])
							if server.vir_teamsenabled and players[i].vir_team then
								table.insert(teamplayers[players[i].vir_team][1],players[i])
							end
							if server.vir_infectionstarted or (not server.vir_playerhasbeeninitial[i]) then
								table.insert(validplayers,players[i])
							end
							if server.vir_lastplayermode then
								players[i].kartstuff[k_bumper] = 5
								players[i].kartstuff[k_wanted] = 100
								if players[i].kartstuff[k_itemroulette] then
									players[i].kartstuff[k_roulettetype] = 1 --Super items for the last player because why not, they've already won
								end
							else
								if players[i].kartstuff[k_squishedtimer] or players[i].kartstuff[k_spinouttimer] then --Freeze last move timer while player doesn't have control
									players[i].vir_lastmovetime = players[i].vir_lastmovetime + 1
								else
									local speed = abs(FixedHypot(players[i].mo.momx,players[i].mo.momy))
									if speed >= 10*FRACUNIT then
										if players[i].vir_lastmovex == nil then
											players[i].vir_lastmovetime = leveltime
										else --Player must move out of the recorded range before they can be considered to be moving
											local distance = abs(FixedHypot(players[i].vir_lastmovex-players[i].mo.x,players[i].vir_lastmovey-players[i].mo.y))/FRACUNIT
											if distance >= 300 then
												players[i].vir_lastmovetime = leveltime
												players[i].vir_lastmovex = nil
												players[i].vir_lastmovey = nil
											else
												players[i].vir_lastmovetime = players[i].vir_lastmovetime + 1
											end
										end
									else
										if players[i].vir_lastmovex == nil then
											players[i].vir_lastmovex = players[i].mo.x
											players[i].vir_lastmovey = players[i].mo.y
										else
											local distance = abs(FixedHypot(players[i].vir_lastmovex-players[i].mo.x,players[i].vir_lastmovey-players[i].mo.y))/FRACUNIT
											if distance >= 200 then
												players[i].vir_lastmovex = players[i].mo.x
												players[i].vir_lastmovey = players[i].mo.y
											end
										end
										if speed >= 6*FRACUNIT then --Also freeze timer when effectively reversing full throttle
											players[i].vir_lastmovetime = players[i].vir_lastmovetime + 1
										end
									end
								end
								if leveltime >= players[i].vir_lastmovetime + (15*TICRATE) and (not players[i].kartstuff[k_hyudorotimer]) then --If a player is idle for 15 seconds, infected players are able to get an SPB to ruin their day
									local idletime = leveltime - players[i].vir_lastmovetime
									if idletime > longestidletime then
										longestidletime = idletime
										longestidler = players[i]
									end
								end
								if server.vir_activespb and players[i] == server.vir_spbtarget then --Can't modify the SPB's target when its far away (it can only change via lua after the siren goes off), so have to put the target player into "1st"
									players[i].kartstuff[k_bumper] = 4
								else
									players[i].kartstuff[k_bumper] = 3
								end
								players[i].kartstuff[k_wanted] = 10
							end
							if players[i].kartstuff[k_itemtype] == KITEM_SPB then --Non-infected players should not have an SPB; Replace with 4x Orbis
								players[i].kartstuff[k_itemtype] = KITEM_ORBINAUT
								players[i].kartstuff[k_itemamount] = 4
								if players[i].kartstuff[k_stealingtimer] then --If it was stolen, make note that it was removed from play to allow another one to show up
									server.vir_spbinplay = false
								end
							elseif players[i].kartstuff[k_itemtype] == KITEM_EGGMAN then --Same with Eggman items, except replace with Bananas
								players[i].kartstuff[k_itemtype] = KITEM_BANANA
								players[i].kartstuff[k_itemamount] = 3
							end
							if newscore then
								players[i].marescore = newscore
								K_KartUpdatePosition(players[i])
							end
						end
					end
					
					if players[i].vir_itemroulette then --Keep track of the player's roulette here
						if not players[i].kartstuff[k_itemroulette] and players[i].kartstuff[k_itemtype] then
							VIR_GiveRouletteItem(i)
							players[i].vir_itemroulette = 0
						else
							players[i].vir_itemroulette = players[i].kartstuff[k_itemroulette]
						end
					elseif players[i].kartstuff[k_itemroulette] then
						players[i].vir_itemroulette = 1
					end
					
					if players[i].vir_infected and (players[i].kartstuff[k_itemtype] == KITEM_HYUDORO or players[i].kartstuff[k_itemtype] == KITEM_THUNDERSHIELD) then --Remove Hyudoro and Thunder Shield if a player is infected while holding either one
						VIR_RemoveItem(players[i])
					elseif players[i].kartstuff[k_itemtype] == KITEM_THUNDERSHIELD and not players[i].vir_autouseshieldtime then --Ensure that the shield timer is set if the shield was stolen
						players[i].vir_autouseshieldtime = leveltime + vir_shieldtime
					end
					if players[i].vir_usingshield then --Thunder shield gives 1 frame of immunity to infection to give time to damage nearby infected
						players[i].vir_usingshield = false
					end
					if players[i].vir_autouseshieldtime then --Thunder Shield will automatically expire after 10 seconds
						if players[i].kartstuff[k_itemtype] == KITEM_THUNDERSHIELD and players[i].kartstuff[k_itemamount] then
							if leveltime >= players[i].vir_autouseshieldtime then
								VIR_DoThunderShield(players[i])
							end
						else
							players[i].vir_autouseshieldtime = 0
						end
					end
					
				end
			elseif server.vir_playernames[i] then --Player disconnected; Take note of their name and whether they had been an initial infected this rotation
				if server.vir_playerhasbeeninitial[i] then
					server.vir_playerleftafterinitial[server.vir_playernames[i]] = true
				end
				server.vir_playerhasbeeninitial[i] = false
				server.vir_playernames[i] = nil
			end
		end
		if leveltime >= vir_starttime then
			local RedAllInfected = #teamplayers[1][1] <= 0 and server.vir_teamsenabled
			local BlueAllInfected = #teamplayers[2][1] <= 0 and server.vir_teamsenabled
			local RedNeedsInfected = #teamplayers[1][2] <= 0 and server.vir_teamsenabled
			local BlueNeedsInfected = #teamplayers[2][2] <= 0 and server.vir_teamsenabled
			if #initialinfectednames > 0 then
				server.vir_infectionstarted = true
				if #initialinfectednames == 1 then
					print(initialinfectednames[1].."\x80 has been infected!")
				else
					print(initialinfectednames[1].."\x80 and "..initialinfectednames[2].."\x80 have been infected!")
				end
			end
			if leveltime - server.vir_lastspbtime >= 15*TICRATE then
				if longestidler then --Idling players are eligible to receive a nasty surprise
					if not (longestidler == server.vir_spbtarget) then
						server.vir_spbtarget = longestidler
					end
				elseif server.vir_spbtarget and ((not server.vir_spbinplay) or (not server.vir_spbtarget.valid) or server.vir_spbtarget.spectator or server.vir_spbtarget.vir_infected) then --Unless the player gets infected, spectates, or disconnects, there's nothing stopping the SPB
					server.vir_spbtarget = nil
				end
			elseif server.vir_spbtarget then
				server.vir_spbtarget = nil
			end
			if #validplayers <= 0 then --fallback if something goes wrong
				validplayers = runningplayers
			end
			if #runningplayers > 0 and (not (RedAllInfected or BlueAllInfected)) then --Initial infection and also ensuring that at least 1 player is infected at all times (in case of disconnects)
				if #infectedplayers == 0 or RedNeedsInfected or BlueNeedsInfected then
					if server.vir_teamsenabled then
						if RedNeedsInfected then
							VIR_SelectInfected(1,validplayers,teamplayers[1][1])
						end
						if BlueNeedsInfected then
							VIR_SelectInfected(2,validplayers,teamplayers[2][1])
						end
					else
						if #runningplayers > 1 and #validplayers > 0 then
							local selectedplayer = VIR_SelectInfected(0,validplayers,runningplayers)
							if (not server.vir_infectionstarted) and (#runningplayers >= 6 or server.vir_teamsenabled) then --Select a 2nd initial infected if at 6+ players
								VIR_SelectInfected(0,validplayers,runningplayers,selectedplayer)
							end
						elseif server.vir_infectionstarted then --Should only trigger if the last infected disconnects and leaves 1 player (1 player free play just won't start the scripting)
							VIR_EndBattle()
						end
					end
				elseif (not server.vir_teamsenabled) and #runningplayers == 1 and not server.vir_endinground then --Last player mode (battle will end 30 seconds after only one player remains)
					if server.vir_lastplayermode then
						if leveltime >= server.vir_lastplayerstarttime + 30*TICRATE then
							VIR_EndBattle()
						end
					elseif leveltime > server.vir_lastinfecttime + 5*TICRATE	then
						server.vir_lastplayermode = true
						server.vir_lastplayerstarttime = leveltime
						print(runningplayers[1].name.." is the Last Player!")
						--K_CalculateBattleWanted() --would be really cool if there was a way to directly influence the wanted players
					end
				end
			elseif #infectedplayers > 0 then
				VIR_EndBattle()
			end
			for i = 1,#infectedplayers,1 do
				infectedplayers[i].mo.colorized = false
				if infectedplayers[i].kartstuff[k_invincibilitytimer] then --Invuln shouldn't come up during team mode
					infectedplayers[i].mo.frame = $|FF_FULLBRIGHT
					local color = (leveltime/2)%10
					if color >= 5 then
						color = color - 5
						infectedplayers[i].mo.color = SKINCOLOR_SUPER1 + color
					else
						infectedplayers[i].mo.color = SKINCOLOR_GSUPER1 + color
					end
					infectedplayers[i].mo.colorized = false
				else
					if infectedplayers[i].vir_caninfect then
						infectedplayers[i].mo.frame = $|FF_FULLBRIGHT
						infectedplayers[i].mo.color = vir_teamcolors[infectedplayers[i].vir_team][2] + (leveltime/3)%3
						infectedplayers[i].mo.colorized = false
						infectedplayers[i].kartstuff[k_speedboost] = max(infectedplayers[i].kartstuff[k_speedboost], FRACUNIT/10)
					else
						infectedplayers[i].mo.color = vir_teamcolors[infectedplayers[i].vir_team][2]+2
						infectedplayers[i].mo.colorized = false
						infectedplayers[i].mo.friction = $-($/176)
					end
				end
			end
			
			if server.vir_activespb and not server.vir_activespb.valid then
				server.vir_activespb = nil
				server.vir_spbteam = -1
			end
			if server.vir_spbinplay then --Make note of if the player with the SPB disconnects or spectates, or if something happens to the SPB
				if (not server.vir_activespb) and (server.vir_playerwithspb >= 0 and (players[server.vir_playerwithspb] and ((not players[server.vir_playerwithspb].valid) or players[server.vir_playerwithspb].spectator))) then
					server.vir_spbinplay = false
					server.vir_playerwithspb = -1
				end
			end
			if server.vir_playerwithshield >= 0 then --Check if the player with the thunder shield still has it
				if not (players[server.vir_playerwithshield] and players[server.vir_playerwithshield].valid and (not players[server.vir_playerwithshield].spectator) and players[server.vir_playerwithshield].kartstuff[k_itemtype] == KITEM_THUNDERSHIELD) then
					server.vir_playerwithshield = -1
				end
			end
		end
		
		server.vir_eggboxesinplay = 0 --reset every frame so that the thinkers can count them
	end
end)

addHook("MobjCollide", function(mo, mo2)
	if (not server.vir_enabled) or server.vir_endinground then return end
	if (mo2 and mo2.valid) and mo2.player then
		if mo.player.vir_infected then --Initiating player is infected
			if not mo2.player.vir_infected then --Infected players have no affect on eachother
				VIR_AttemptInfection(mo2,mo)
			end
		elseif mo2.player.vir_infected then --Other player is infected
			VIR_AttemptInfection(mo,mo2)
		end
	end
end, MT_PLAYER)

addHook("MobjThinker", function(bumper) --Don't need bumpers
	if not server.vir_enabled then return end
	if (bumper and bumper.valid) and leveltime > 2 then --2 frames of thinkers occur before MapLoad, where all the variables are set
		P_KillMobj(bumper)
	end
end, MT_BATTLEBUMPER)

addHook("MobjThinker", function(wanted) --Delete regular Wanted sign; I make my own
	if not server.vir_enabled then return end
	if leveltime > 2 then
		P_KillMobj(wanted)
	end
end, MT_PLAYERWANTED)

addHook("MobjThinker", function(marker) --Hide regular player markers and spawn in new versions intended for Virus
	if not server.vir_enabled then return end
	if leveltime > 2 then
		marker.flags = $|MF2_DONTDRAW
		if not marker.virusmarker then
			marker.virusmarker = P_SpawnMobj(marker.x,marker.y,marker.z,MT_VIRUSPLAYERARROW)
			marker.virusmarker.target = marker
			marker.virusmarker.movecount = 0
		end
	end
end, MT_PLAYERARROW)

addHook("MobjThinker", function(marker) --Thinker for the Virus Player Arrows
	if marker.target then
		if marker.target.target and marker.target.target.player then
			local player = marker.target.target.player
			if VIR_IsLocalPlayer(player) or (player.mo.flags2 & MF2_DONTDRAW) or (player.kartstuff[k_hyudorotimer] and not player.kartstuff[k_stealingtimer]) then
				marker.flags = $|MF2_DONTDRAW
			else
				local newstate = 1 --Enemy Infected
				if not player.vir_infected then
					if server.vir_teamsenabled then
						if vir_localteam > 0 and player.vir_team == vir_localteam then
							newstate = 5 --Team Runner
						else
							newstate = 4 --Enemy Runner
						end
					else
						newstate = 2 --Another Runner
						if vir_localplayerisinfected and (leveltime/4)%2 then
							newstate = 3 --Flashing Frame (when viewer infected)
						end
						if server.vir_lastplayermode and not marker.movecount then --Create Wanted indicator in Last Player mode
							local wanted = P_SpawnMobj(marker.x, marker.y, marker.z, MT_VIRUSWANTED)
							wanted.target = marker.target.target
							wanted.tracer = marker
							wanted.scale = marker.scale
							wanted.destscale = marker.scale
							marker.movecount = 1
						end
					end
				elseif server.vir_teamsenabled and vir_localteam > 0 and player.vir_team == vir_localteam then
					newstate = 6 --Team Infected
				end
				if player.kartstuff[k_itemroulette] or player.kartstuff[k_stolentimer] > 0 or (player.kartstuff[k_stealingtimer] > 0 and leveltime%2) or (player.kartstuff[k_itemtype] and player.kartstuff[k_itemamount] > 0) then --There's more conditions, but they aren't necessary for Virus
					newstate = newstate + 6 --Move to other side of the table to get the box version
				end
				marker.state = vir_playerarrowstates[newstate]
				if player.vir_infected and not player.vir_caninfect then
					marker.color = SKINCOLOR_NICKEL
				else
					marker.color = marker.target.color
				end
				if player.mo.eflags & MFE_VERTICALFLIP then
					marker.eflags = $|MFE_VERTICALFLIP --The position sorta gets messed up at higher scales when flipped, but I imagine the vanilla one does as well so I can't really mess with it
				else
					marker.eflags = $ & ~MFE_VERTICALFLIP
				end
				marker.flags = $ & ~MF2_DONTDRAW
			end
			P_TeleportMove(marker,marker.target.x,marker.target.y,marker.target.z)
			marker.destscale = marker.target.scale
		end
	else
		P_KillMobj(marker,nil,nil)
	end
end, MT_VIRUSPLAYERARROW)

addHook("MobjThinker", function(wanted) --Thinker for the Virus Wanted indicator
	if wanted.target and wanted.tracer and wanted.tracer.target then
		if wanted.target.player then
			local player = wanted.target.player
			local marker = wanted.tracer.target
			
			if player.vir_infected then
				wanted.tracer.movecount = 0
				P_KillMobj(wanted,nil,nil)
			else
				local newscale = 3 * wanted.target.scale
				if (not splitscreen) and vir_localviewers[1] then
					newscale = wanted.target.scale + FixedMul(FixedDiv(abs(P_AproxDistance(vir_localviewers[1].mo.x-wanted.target.x, vir_localviewers[1].mo.y-wanted.target.y)), RING_DIST), wanted.target.scale)
					if (newscale > 16*wanted.target.scale)
						newscale = 16*wanted.target.scale
					end
				end
				wanted.destscale = newscale
				local new_z = marker.z
				if VIR_IsLocalPlayer(player) or (player.mo.flags2 & MF2_DONTDRAW) or (player.kartstuff[k_hyudorotimer] and not player.kartstuff[k_stealingtimer]) then
					wanted.flags = $|MF2_DONTDRAW
				else
					if player.mo.eflags & MFE_VERTICALFLIP then
						wanted.eflags = $|MFE_VERTICALFLIP
						new_z = wanted.target.z - (P_GetPlayerHeight(wanted.target.player)) - (16*wanted.target.scale) - (64*newscale)
					else
						wanted.eflags = $ & ~MFE_VERTICALFLIP
						new_z = wanted.target.z + (P_GetPlayerHeight(wanted.target.player)) + (16*wanted.target.scale) + (64*newscale);
					end
					wanted.flags = $ & ~MF2_DONTDRAW
				end
				P_TeleportMove(wanted,marker.x,marker.y,new_z)
			end
		end
	else
		P_KillMobj(wanted,nil,nil)
	end
end, MT_VIRUSWANTED)

addHook("MobjSpawn", function(spbboom) --In team modes, apply the player's team to the SPB explosions
	if not server.vir_enabled then return false end
	if server.vir_teamsenabled and spbboom.extravalue1 then
		if spbboom.target and spbboom.target.player and spbboom.target.player.vir_team then
			spbboom.vir_team = spbboom.target.player.vir_team
		else
			spbboom.vir_team = server.vir_spbteam
		end
	end
end, MT_SPBEXPLOSION)

addHook("MobjThinker", function(spb) --SPB handler
	if not server.vir_enabled then return end
	if not server.vir_activespb then
		server.vir_activespb = spb
		if server.vir_teamsenabled and spb.target and spb.target.player then --Copy the player's team to the SPB in team mode
			server.vir_spbteam = spb.target.player.vir_team --Fallback in case the person who fired it vanishes off the face of the planet
		end
	end
	server.vir_playerwithspb = -1 --no longer need to make sure the player with the SPB is still in the game
	if spb.tracer and spb.tracer.player then
		if (not server.vir_spbtarget) or (server.vir_spbtarget.vir_team == server.vir_spbteam) then --Detonate SPB if the intended target disconnects or is infected mid-flight (or ends up being same team somehow)
			S_StopSound(spb)
			local spbexplosion = P_SpawnMobj(spb.x,spb.y,spb.z,MT_SPBEXPLOSION)
			spbexplosion.extravalue1 = 1
			if spb.target then
				spbexplosion.target = spb.target
			end
			P_KillMobj(spb)
			server.vir_spbinplay = false
		elseif server.vir_spbtarget.mo then
			spb.tracer = server.vir_spbtarget.mo
			if server.vir_spbtarget.kartstuff[k_hyudorotimer] or (server.vir_spbtarget.health == 0) then --Freeze in place if target is using Hyudoro or falling in a pit
				spb.momx = 0
				spb.momy = 0
				spb.momz = 0
			end
		end
	end
end, MT_SPB)

local HandleEggmanThink = --Color handler for Egg Boxes
	function(egg,isdragitem)
		if egg.vir_team == nil then
			if server.vir_teamsenabled and egg.target and egg.target.player then
				egg.vir_team = egg.target.player.vir_team
			else
				egg.vir_team = 0
			end
		end
		server.vir_eggboxesinplay = server.vir_eggboxesinplay + 1
		if isdragitem then --Drag item is always colored
			egg.colorized = true
		else
			local closestdistance
			for i = 0,15,1 do
				if players[i] and players[i].valid and (not (players[i].spectator or players[i].vir_infected)) then
					local distance = abs(FixedHypot(egg.x-players[i].mo.x,egg.y-players[i].mo.y))/FRACUNIT
					if distance <= 600 then
						if (not closestdistance) or (distance < closestdistance) then
							closestdistance = distance
						end
					end
				end
			end
			if closestdistance then
				if closestdistance <= 300 then --Solid green when non-infected is really close
					egg.colorized = true
				else --Flashing green when non-infected is sorta close
					if leveltime%2 then
						egg.colorized = true
					else
						egg.colorized = false
					end
				end
			else --Normal color when no non-infected are nearby
				egg.colorized = false
			end
		end
		if egg.colorized then
			if (leveltime/2)%2 then
				egg.color = vir_teamcolors[egg.vir_team][2]
			else
				if (leveltime/4)%2 then
					egg.color = vir_teamcolors[egg.vir_team][2]-2
				else
					egg.color = vir_teamcolors[egg.vir_team][2]+2
				end
			end
		end
	end

addHook("MobjThinker", function(egg)
	if not server.vir_enabled then return false end
	HandleEggmanThink(egg)
end, MT_EGGMANITEM)

addHook("MobjThinker", function(egg)
	if not server.vir_enabled then return false end
	HandleEggmanThink(egg,true)
end, MT_EGGMANITEM_SHIELD)

local HandleEggmanTouch = --Eggbox handler; Infects players who aren't infected, and can be recollected by infected
	function(item, mo, isdragitem)
		if mo and mo.player then
			if mo.player.vir_infected and (not isdragitem) then --Infected players must have no items on hand (not even a roulette running) to be able to pick up egg boxes
				if P_IsObjectOnGround(mo) and ((not (item.target == mo)) or (item.threshold == 0)) and mo.player.kartstuff[k_itemtype] == KITEM_NONE and mo.player.kartstuff[k_itemamount] == 0 and mo.player.kartstuff[k_itemroulette] == 0 and mo.player.kartstuff[k_eggmanheld] == 0 then
					mo.player.kartstuff[k_itemtype] = KITEM_EGGMAN
					mo.player.kartstuff[k_itemamount] = 1
					mo.player.kartstuff[k_itemblink] = TICRATE
					mo.player.kartstuff[k_itemblinkmode] = 0
					if VIR_IsLocalPlayer(mo.player) then
						S_StartSound(nil,sfx_itrolf)
					end
					local poof = P_SpawnMobj(item.x, item.y, item.z, MT_EXPLODE);
					S_StartSound(poof, item.info.deathsound)
					P_KillMobj(item, mo, mo)
				end
			elseif (not mo.player.vir_infected) and (not mo.player.kartstuff[k_hyudorotimer]) and (not mo.player.vir_usingshield) then

				mo.momz = 18*mapobjectscale*P_MobjFlip(mo)
				mo.momx = 0
				mo.momy = 0

				mo.player.kartstuff[k_sneakertimer] = 0
				mo.player.kartstuff[k_driftboost] = 0

				mo.player.kartstuff[k_drift] = 0
				mo.player.kartstuff[k_driftcharge] = 0
				mo.player.kartstuff[k_pogospring] = 0

				mo.player.kartstuff[k_spinouttype] = 1
				mo.player.kartstuff[k_spinouttimer] = (3*TICRATE/2)+2

				P_PlayRinglossSound(mo)
				mo.player.kartstuff[k_instashield] = 16
				mo.player.powers[pw_flashing] = K_GetKartFlashing(mo.player)
				
				if (mo.player.kartstuff[k_itemtype] == KITEM_THUNDERSHIELD and mo.player.kartstuff[k_itemamount]) then --Thunder Shield prevents infection, but still spins out
					VIR_DoThunderShield(mo.player)
					if item.target and item.target.valid and item.target.player then
						VIR_HitfeedMessage(item.target.player, mo.player, "K_HMEGG")
					else
						VIR_HitfeedMessage(nil, mo.player, "K_HMEGG")
					end
				else
					VIR_DropHeldItems(mo.player)
					if (not server.vir_teamsenabled) or (not (mo.player.vir_team == item.vir_team)) then
						VIR_TakeDamage(mo.player,3)
						if item.target and item.target.valid then
							K_PlayHitEmSound(item.target)
						end
						if item.target and item.target.valid and item.target.player then
							VIR_HitfeedMessage(item.target.player, mo.player, "K_VRHIT")
						else
							VIR_HitfeedMessage(nil, mo.player, "K_VRHIT")
						end
					else
						if item.target and item.target.valid and item.target.player then
							VIR_HitfeedMessage(item.target.player, mo.player, "K_HMEGG")
						else
							VIR_HitfeedMessage(nil, mo.player, "K_HMEGG")
						end
					end
				end
				local explosion = P_SpawnMobj(item.x, item.y, item.z, MT_SPBEXPLOSION)
				if item.target and item.target.valid then
					explosion.target = item.target
				end
				P_KillMobj(item, mo, mo)
			end
		end
	end

addHook("TouchSpecial", function(item, mo)
	if not server.vir_enabled then return false end
	HandleEggmanTouch(item, mo)
	return true
end, MT_EGGMANITEM)

addHook("TouchSpecial", function(item, mo)
	if not server.vir_enabled then return false end
	HandleEggmanTouch(item, mo, true)
	return true
end, MT_EGGMANITEM_SHIELD)


local VIR_DoHitEmSound = --Determine if its appropriate to play the Hit'Em sound for the "Should____" hooks
	function(sourcemo,target)
		if sourcemo and sourcemo.player then
			if server.vir_teamsenabled then --Teams: Whenever hitting a player on the opposite team, unless its infected VS runner specifically
				if (not (sourcemo.player.vir_team == target.vir_team)) and ((not sourcemo.player.vir_infected) or target.vir_infected) then
					K_PlayHitEmSound(sourcemo)
				end
			elseif target.vir_infected and (not sourcemo.player.vir_infected) then --FFA: Only when a runner hits an infected player
				K_PlayHitEmSound(sourcemo)
			end
		end
	end

addHook("ShouldSpin", function(player, inflictor, source) --Mostly copied from source code, with damage and scoring removed
	if not server.vir_enabled then return end
	if (player.powers[pw_flashing] > 0 or player.kartstuff[k_squishedtimer] > 0 or player.kartstuff[k_spinouttimer] > 0 or player.kartstuff[k_hyudorotimer] > 0) then
		K_DoInstashield(player)
	else
		player.kartstuff[k_driftboost] = 0
		player.kartstuff[k_drift] = 0
		player.kartstuff[k_driftcharge] = 0
		player.kartstuff[k_pogospring] = 0
		
		if inflictor and (inflictor.type >= 444 and inflictor.type <= 448) then --Orbinauts and Jawz cause wipeouts instead of spinouts
			player.kartstuff[k_spinouttype] = 1
		else
			player.kartstuff[k_spinouttype] = 0
			if (player.speed < K_GetKartSpeed(player, true)/4) then
				P_InstaThrust(player.mo, player.mo.angle, FixedMul(K_GetKartSpeed(player, true)/4, player.mo.scale))
			end
			S_StartSound(player.mo, sfx_slip)
		end
		
		player.kartstuff[k_spinouttimer] = (3*TICRATE/2)+2
		player.kartstuff[k_instashield] = 15
		player.powers[pw_flashing] = K_GetKartFlashing(player)
		
		if player.kartstuff[k_itemtype] == KITEM_THUNDERSHIELD and player.kartstuff[k_itemamount] then --Use Thunder Shield instead of taking damage
			VIR_DoThunderShield(player)
		else
			VIR_DropHeldItems(player)
			VIR_DoHitEmSound(source,player)
			if ( (not source) or (not source.player) ) and ( (not inflictor) or (not vir_sourcedoesntinfect[inflictor.type]) ) then --environmental damage
				VIR_TakeDamage(player,1)
			end
		end
		if hitfeed and source and source.player then
			VIR_HitfeedMessage(source.player, player, HF_GetIcon_Spin(player, inflictor, source))
		end
			
	end
	return false
end)

addHook("ShouldExplode", function(player, inflictor, source) --Mostly copied from source code, with damage and scoring removed
	if not server.vir_enabled then return end
	local isspb = (inflictor and inflictor.type == MT_SPBEXPLOSION) and inflictor.extravalue1
	local isintendedtarget = isspb and (player == server.vir_spbtarget) and (not server.vir_endinground) and (not (player.vir_team == inflictor.vir_team))
	if (not isintendedtarget) and ((player.powers[pw_flashing] > 0) or player.kartstuff[k_squishedtimer] > 0 or player.kartstuff[k_hyudorotimer] > 0) then
		K_DoInstashield(player)
	else
		player.mo.momz = 18*mapobjectscale*P_MobjFlip(player.mo)
		player.mo.momx = 0
		player.mo.momy = 0

		player.kartstuff[k_sneakertimer] = 0
		player.kartstuff[k_driftboost] = 0

		player.kartstuff[k_drift] = 0
		player.kartstuff[k_driftcharge] = 0
		player.kartstuff[k_pogospring] = 0

		player.kartstuff[k_spinouttype] = 1
		player.kartstuff[k_spinouttimer] = (3*TICRATE/2)+2

		player.powers[pw_flashing] = K_GetKartFlashing(player)
		
		local shieldwentoff = false
		
		local spbhit = false
		if isspb then
			player.kartstuff[k_spinouttimer] = ((5*player.kartstuff[k_spinouttimer])/2)+1
			player.mo.momz = player.mo.momz * 2
			if isintendedtarget then --Infect the player fully if they are the desired target of the SPB (and not the same team)
				if player.kartstuff[k_itemtype] == KITEM_THUNDERSHIELD and player.kartstuff[k_itemamount] then --UNLESS they have a Thunder Shield, but the timer won't be reset
					VIR_DoThunderShield(player)
					shieldwentoff = true
					if source and source.player then
						VIR_HitfeedMessage(source.player, player, "K_HMSPB")
					else
						VIR_HitfeedMessage(nil, player, "K_HMSPB")
					end
				else
					VIR_TakeDamage(player,3)
					server.vir_lastspbtime = leveltime
					spbhit = true
					if source and source.player then
						VIR_HitfeedMessage(source.player, player, "K_VRHIT")
					else
						VIR_HitfeedMessage(nil, player, "K_VRHIT")
					end
				end
			end
			server.vir_spbinplay = false
		end

		if (player.mo.eflags & MFE_UNDERWATER) then
			player.mo.momz = (117 * player.mo.momz) / 200
		end

		P_PlayRinglossSound(player.mo)
		player.kartstuff[k_instashield] = 15
		
		if not shieldwentoff then --In case the Thunder Shield went off earlier in this function
			if player.kartstuff[k_itemtype] == KITEM_THUNDERSHIELD and player.kartstuff[k_itemamount] then --Use Thunder Shield instead of taking damage
				VIR_DoThunderShield(player)
				if hitfeed and (not isintendedtarget) and source and source.player then
					VIR_HitfeedMessage(source.player, player, HF_GetIcon_Explode(player, inflictor, source))
				end
			else
				VIR_DropItems(player)
				if spbhit then --For sure play sound when the hit is from a successful SPB infection
					K_PlayHitEmSound(source)
				else
					VIR_DoHitEmSound(source,player)
				end
				if ( (not source) or (not source.player) ) and ( (not inflictor) or (not vir_sourcedoesntinfect[inflictor.type]) ) then --environmental damage
					VIR_TakeDamage(player,1)
				end
				if hitfeed and (not isintendedtarget) and source and source.player then
					VIR_HitfeedMessage(source.player, player, HF_GetIcon_Explode(player, inflictor, source))
				end
			end
		end
		
	end
	return false
end)

addHook("ShouldSquish", function(player, inflictor, source) --This should only come up in levels, since Grow is removed
	if not server.vir_enabled then return end
	if (player.powers[pw_flashing] > 0 or player.kartstuff[k_squishedtimer] > 0 or player.kartstuff[k_hyudorotimer] > 0) then
		K_DoInstashield(player)
	else
		player.kartstuff[k_sneakertimer] = 0
		player.kartstuff[k_driftboost] = 0

		player.kartstuff[k_drift] = 0
		player.kartstuff[k_driftcharge] = 0
		player.kartstuff[k_pogospring] = 0
		
		player.kartstuff[k_squishedtimer] = TICRATE

		-- Reduce Shrink timer
		if (player.kartstuff[k_growshrinktimer] < 0) then
			player.kartstuff[k_growshrinktimer] = player.kartstuff[k_growshrinktimer] + TICRATE
			if (player.kartstuff[k_growshrinktimer] >= 0) then
				K_RemoveGrowShrink(player);
			end
		end

		player.powers[pw_flashing] = K_GetKartFlashing(player)
		player.mo.flags = $|MF_NOCLIP
		P_PlayRinglossSound(player.mo)
		player.kartstuff[k_instashield] = 15
		
		if player.kartstuff[k_itemtype] == KITEM_THUNDERSHIELD and player.kartstuff[k_itemamount] then --Use Thunder Shield instead of taking damage
			VIR_DoThunderShield(player)
		else
			VIR_DropItems(player)
			VIR_DoHitEmSound(source,player)
			if ( (not source) or (not source.player) ) and ( (not inflictor) or (not vir_sourcedoesntinfect[inflictor.type]) ) then --environmental damage
				VIR_TakeDamage(player,1)
			end
		end
		
	end
	return false
end)